<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Numerous product, date  category subroutines
'*********************************************************************************

sub SetupProductFieldsXXX (ProdFields, ProdHeaders)
   dim tempfields, swords(20), swordscount, i
   tempfields = GetConfig("xproductfields")
   ParseRecord tempfields, swords, swordscount, ","
   redim prodFields(swordscount -1)
   for i = 0 to swordscount -1
      prodfields(i) = swords(i)
   next
end sub

sub SetupSearchFields (SearchFields)
   dim tempfields, swords(20), swordscount, i
   if strSearchFields = "" then
      tempfields = GetConfig("xsearchfields")
   else
      tempfields = strSearchFields
   end if
   
   ParseRecord tempfields, swords, swordscount, ","
   redim SearchFields(swordscount -1)
   for i = 0 to swordscount -1
      searchfields(i) = swords(i)
   next
end sub

' This routine puts fields into the cart
sub GetNameInCart (Rsitem, dbc)
   dim tempfields, cartfields(20), fieldcount, i, fieldvalue
   dim tempCatalogId
   tempfields = GetConfig("xcartfields")
   if tempfields = "" then
      ShopError GetLang("langcommonno") & " " & GetLang("langsearchfields") & " to " & GetLang("langeditdisplay")
   end if

   ParseRecord tempfields, cartfields, fieldcount, ","
   nameincart = ""
   tempCatalogId = rsitem("CatalogId")
   for i = 0 to fieldcount -1
      if cartfields(i) = "cdescription" then
         fieldvalue = memCDescription
         fieldvalue = TranslateLanguage(dbc, "products", "cdescription", "CatalogId", tempCatalogId, fieldvalue)
      else
         fieldvalue = rsitem(cartfields(i))
         if lcase(cartfields(i)) = "cname" then
            '6.50.4 - show parent name before child name in cart
			'700 - 2010.05.03 - Check all databasae must close after opened.
            dim childrs, childrs2
            Set childrs = Server.CreateObject("ADODB.Recordset")
            '700 - 2010.09.26 - Enhancement: Speed up front store performance
			'701 - 2011.03.15 - Enhancement: Speed up store performance
            childrs.open "select higherCatalogId from products where CatalogId = " & tempCatalogId, dbc, adOpenForwardOnly, adLockReadOnly
            if not childrs.eof then
               if childrs("higherCatalogId") > 0 then
			      '700 - 2010.05.03 - Check all databasae must close after opened.
                  Set childrs2 = Server.CreateObject("ADODB.Recordset")
                  '700 - 2010.09.26 - Enhancement: Speed up front store performance
				  '701 - 2011.03.15 - Enhancement: Speed up store performance
                  childrs2.open "select CatalogId, cname from products where CatalogId IN (SELECT higherCatalogId FROM products where CatalogId = " & tempCatalogId & ")", dbc, adOpenForwardOnly, adLockReadOnly
                  if not childrs2.eof then
                     fieldvalue = TranslateLanguage(dbc, "products", "cname", "CatalogId", childrs2("CatalogId"), childrs2("cname")) & " - " & TranslateLanguage(dbc, "products", "cname", "CatalogId", tempCatalogId, fieldvalue)
                  end if
				  CloseRecordSet childrs2
               end if
            end if
            CloseRecordSet childrs

            if fieldvalue = "" then
               fieldvalue = TranslateLanguage(dbc, "products", "cname", "CatalogId", tempCatalogId, fieldvalue)
            end if

         end if
      end if
      if not isnull(fieldvalue) then
         if nameincart<>"" then
            nameincart = nameincart & "<br />"
         end if
         nameincart = nameincart & fieldvalue
      end if
   next
end sub

function GetMailCR
   GetMailCR = chr(13) & chr(10)
end function

' Used throughout the code to create a text form box
sub CreateCustRow (caption, fieldname, fieldvalue, required,passhelpstring)
   dim aster
   if required = "Yes" then
      aster = "* "
   else
      aster = "  "
   end if
   HtmlWrite tablerow & "<th>"
   HtmlWrite aster & Caption & "</th>"
   HtmlWrite "<td>"
%>
<input class="txtfield" size="20" name="<%=fieldname%>" value="<%=fieldvalue%>" />
<%
   GenHelpIcon(passhelpstring)
   HtmlWrite tablecolumnend & tableRowend
end sub

' Used throughout the code to create a text form box in style
sub CreateCustRowStyle (caption, fieldname, fieldvalue, required,passhelpstring)
   dim aster
   if required = "Yes" then
      aster = "* "
   else
      aster = "  "
   end if
   HtmlWrite "<fieldset>"
   htmlwrite "<label>"& aster &" "& Caption &"</label>"
%>
<input class="txtfield" size="20" name="<%=fieldname%>" value="<%=fieldvalue%>" />
<div class="cb"></div>
<%
   GenHelpIcon(passhelpstring)
   HtmlWrite "</fieldset>"
end sub

sub CreateFieldSetRowP (caption, fieldname, fieldvalue, required)
   dim aster
   if required = "Yes" then
      aster = "* "
   else
      aster = "  "
   end if
   htmlwrite "<fieldset>"
   htmlwrite "<label>" & aster & Caption & "</label>"
%>
<input class="txtfield inputfield" type="password" name="<%=fieldname%>" value="<%=fieldvalue%>" />
<%
   htmlwrite "<div class=""cb""></div>"
   htmlwrite "</fieldset>"
end sub

sub CreateFieldSetRow (caption, fieldname, fieldvalue, required,passhelpstring)
   dim aster
   if required = "Yes" then
      aster = "* "
   else
      aster = "  "
   end if
   
   htmlwrite "<fieldset>"
   htmlwrite "<label>" & aster & Caption & "</label>"
%>
<input class="txtfield inputfield" size="20" name="<%=fieldname%>" value="<%=fieldvalue%>" />
<%
   GenHelpIcon(passhelpstring)
   htmlwrite "<div class=""cb""></div>"
   htmlwrite "</fieldset>"
end sub

sub CreateFieldSetTextAreaRow (caption, fieldname, fieldvalue, required,passhelpstring)
   dim aster
   if required = "Yes" then
      aster = "* "
   else
      aster = "  "
   end if
   
   htmlwrite "<fieldset>"
   htmlwrite "<label>" & aster & Caption & "</label>"

   '701 - 2012.04.11 - Bug Fix: Badly formatted comment box at contact us page if browsed by FF
%>
<textarea class="txtfield" rows="10" name="<%=fieldname%>" cols="40"><%=fieldvalue%></textarea>
<%
   GenHelpIcon(passhelpstring)
   htmlwrite "<div class=""cb""></div>"
   htmlwrite "</fieldset>"
end sub

sub CreateFieldSetPwdRow (caption, fieldname, fieldvalue, required,passhelpstring)
   dim aster
   if required = "Yes" then
      aster = "* "
   else
      aster = "  "
   end if
   
   htmlwrite "<fieldset>"
   htmlwrite "<label>" & aster & Caption & "</label>"
%>
<input type="password" class="txtfield inputfield" size="20" name="<%=fieldname%>" />
<%
   GenHelpIcon(passhelpstring)
   htmlwrite "<div class=""cb""></div>"
   htmlwrite "</fieldset>"
end sub

sub CreateblogsnewsRow (caption, fieldname, fieldvalue, required,passhelpstring)
   dim aster
   if required = "Yes" then
      aster = "* "
   else
      aster = "  "
   end if
   HtmlWrite tablerow & "<td class=""fontbold"">"
   HtmlWrite aster & Caption & "</td>"
   HtmlWrite "<td>"
%>
<input class="txtfield" size="20" name="<%=fieldname%>" value="<%=fieldvalue%>" />
<%
   GenHelpIcon(passhelpstring)
   HtmlWrite tablecolumnend & tableRowend
end sub

sub CreateblogsnewsonepageRow (caption, fieldname, fieldvalue, required,passhelpstring)
   dim aster
   if required = "Yes" then
      aster = "* "
   else
      aster = "  "
   end if
   HtmlWrite "<fieldset >"
   HtmlWrite "<label >" & aster & Caption & "</label>"
%>
<input class="txtfield inputfield" size="20" name="<%=fieldname%>" value="<%=fieldvalue%>" />
    <div class="cb"></div>  
    </fieldset>
<%
   if len(passhelpstring) > 0 then
      htmlwrite "<span>"
      GenHelpIcon(passhelpstring)
      HtmlWrite "</span>"
   end if
end sub

sub CreateCustRowP (caption, fieldname, fieldvalue, required)
   dim aster
   if required = "Yes" then
      aster = "* "
   else
      aster = "  "
   end if
   response.write tablerow & "<th>"
   response.write aster & Caption & "</th>"
   response.write tablecolumn
%>
<input class="txtfield" type=password name="<%=fieldname%>" value="<%=fieldvalue%>">
<%
   response.write tablecolumnend & tableRowend
end sub

' used in the admin section to create a text form box
sub FormatEditRow (caption, fieldname, fieldvalue, passhelpstring)
   if fieldvalue > "" then
      fieldvalue = replace(fieldvalue, """", "&quot;")
   end if

   dim capdisplay
   capdisplay = caption
   if capdisplay = "" then
      capdisplay = fieldname
   end if
   HtmlWrite tablerow & TableColumn& capdisplay & tablecolumnend
   HtmlWrite "<td>" & "<input size=40 name=" & fieldname & " value=" & chr(34) & fieldvalue & chr(34) & ">"
   GenHelpIcon(passhelpstring)
   HtmlWrite "</td>"
   HtmlWrite TableRowEnd
end sub

sub FormatEditRowBoolean (caption, fieldname, fieldvalue, Yesnos, Yesnocount, passhelpstring)
   dim capdisplay
   capdisplay = caption
   if capdisplay = "" then
      capdisplay = fieldname
   end if
   HtmlWrite TableRow
   HtmlWrite TableColumn & capdisplay & "</td>"
   HtmlWrite "<td>"
   GenerateSelectNV YesNos, fieldvalue, fieldname, yesnocount, ""
   GenHelpIcon(passhelpstring)
   HtmlWrite "</td>"
   HtmlWrite TableRowEnd
end sub

' used in admin section to create a static equivalent of a text box
sub FormatEditRowStatic (caption, fieldname, fieldvalue, passhelpstring)
   dim capdisplay, yfont
   capdisplay = caption
   if capdisplay = "" then
      capdisplay = fieldname
   end if
   yfont = xTableRowFont
   HtmlWrite "<tr width='200'>"
   HtmlWrite TableColumn & capdisplay & TableColumnEnd
   HtmlWrite "<td>" & Yfont & fieldvalue & xTableRowFontEnd
   GenHelpIcon(passhelpstring)
   HtmlWrite "</td>"
   HtmlWrite TableRowEnd
end sub

' used in admin area to ceate a multirow text area
sub FormatEditRowTextArea (caption, fieldname, fieldvalue, passhelpstring)
   dim capdisplay, rows
   capdisplay = caption
   if capdisplay = "" then
      capdisplay = fieldname
   end if
   rows = 3
   HtmlWrite TableRow
   HtmlWrite TableColumn & capdisplay & TableColumnEnd
   HtmlWrite "<td align='left'><Textarea rows=" & rows & " cols=40  name='" & fieldname & "'>" & fieldvalue & "</textarea>"
   GenHelpIcon(passhelpstring)
   HtmlWrite "</td>"
   HtmlWrite TableRowEnd
end sub

' if doing help for products and categories
sub FormatEditHelpHeader
   if GetConfig("xproducthelp")<>"Yes" then exit sub
%>
<script language="JavaScript" type="text/javascript">
<!--
function openWindow(url) {
  popupWin = window.open(url,'new_page','width=500,height=300,scrollbars=yes,resizable=yes,menubar=no,toolbar=no,location=no,status=no,directories=no,copyhistory=no')
  popupWin.focus();
}
// done hiding -->
</script>
<%
end sub

' write help column for products and categories
sub FormatEditHelp(fieldname, helpfile)
   if GetConfig("xproducthelp")<>"Yes" then exit sub
   response.write "<td width='25' align='center'>"
%>
<a href="JavaScript:openWindow('<%=helpfile%>#<%=fieldname%>')"><img src="vpasp_configquestion.gif" border="0"></a>
<%
   response.write tablecolumnend
end sub

' creates category drop down list
sub NavigateShowCategories()
   if GetConfig("Xnavigatecategories") = "No" then exit sub
   if GetConfig("xlogonrequired") = "Yes" then
      if GetSess("login") = "" then
         exit sub
      end if
   end if

   if GetConfig("init") = "" then exit sub
   dim cid, name, catSQL, i
   dim strcategory, catcount, categories, maxcategories
   dim catrs, hassubcategory, mylink
   if catcount = "" then catcount = 0

   '6.50 - advanced session handling
   '700 - 2010.06.10 - Enhancement: Better session handling while using xsavesession
   if lcase(xsavesession) = "yes" then
      catcount = 0
   end if

   if catcount = 0 then
      catcount = 0
      maxcategories = GetConfig("xmaxcategories")
      redim categories(maxcategories)
      catSQL = "Select * from categories where highercategoryid=0 and cathide is null "

      '6.09 - add product matching to this sub
      if GetConfig("xproductmatch") = "Yes" then
         '7.00 - enhanced productmatching
         catsql = catsql & " and "
         GenerateProductmatchsqlsubs catsql
      end if

	  '700 - Customer Groups - Matching Custormer match
	  catsql = catsql & GenerateCustomerMatchSQL ("customermatch","excustomermatch","loggedin","and")
	  
      if GetConfig("xselectproductsbylanguage") = "Yes" and GetSess("language")<>"" then
	     '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
         catsql = catsql & " and (catlanguage="& sqlserverprefixn &"'" & GetSess("language") & "'"
         catsql = catsql & " or catlanguage is null)"
      end if
      '6.08 - Order by config option rather than hardcoded
      if GetConfig("xsortcategories") <> "" then
         catSQL = catsql & " order by " & GetConfig("xsortcategories")
      else
         catSQL = catsql & " order by catdescription"
      end if

      Set catrs = Server.CreateObject("ADODB.Recordset")

	  '700 - 2010.08.24 - Enhancement: Speed up initial loading time
      'catrs.open catsql, dbc, adOpenDynamic, adLockOptimistic
	  ShopOpenRecordSet catsql, catrs, 9999, 1

      while not catrs.eof and catcount<maxcategories
         cid = catrs("categoryid")
         name = catrs("catdescription")
         name = TranslateLanguage(dbc, "categories", "catdescription", "categoryid", cid, name)
         hassubcategory = catrs("hassubcategory")
         if isnull(hassubcategory) then
            hassubcategory = ""
         end if
         if hasSubcategory = "" then
            mylink = "<a href=""shopdisplayproducts.asp?id=" & cid & "&amp;cat=" & Server.URLEncode(replace(name,"&amp;","&")) & addwebsesslink & """>" & name & "</a>"
         else
            mylink = "<a href=""shopDisplayCategories.asp?id=" & cid & "&amp;cat=" & Server.URLEncode(replace(name,"&amp;","&")) & addwebsesslink & """>" & name & "...</a>"
         end if
		 '700 - SEO
 	     genseocategoryproductlink mylink,catrs("categoryid"),name,name,hasSubcategory,"Yes"
         categories(catcount) = mylink
         catcount = catcount + 1
         catrs.MoveNext
      wend
      SetSessA "categories", categories
      SetSess "catcount", catcount
	  '700 - 2010.05.03 - Check all databasae must close after opened.
	  closerecordset catrs
   end if

   catcount = GetSess("catcount")
   categories = GetSessa("categories")
   'response.write NavCatTable
   'htmlwrite "<ul id=""noncatnav"">"
   htmlwrite "<ul class=""menulist"">"
   for i = 0 to catcount -1
      mylink = categories(i)
      'response.write NavCatRow & NavCatColumn
	  htmlwrite "<li>"
      response.write mylink
      'response.write NavCatColumnend
	  htmlwrite "</li>"
   next
   'response.write "</table>"
   htmlwrite "</ul>"
   exit sub
end sub

'700 - Category Menu Enhancements - create sub link
sub generatesublinks(pcid,plink,itype)
   if pcid = "" then exit sub
   
   dim name, catSQL, i,cid
   dim strcategory, catcount, categories, maxcategories
   dim catrs, hassubcategory,mylink,mylink2
   if catcount = "" then catcount = 0

   maxcategories = GetConfig("xmaxcategories")
   redim categories(maxcategories)   
   catSQL = "Select * from categories where highercategoryid="& pcid &" and cathide is null "
   if GetConfig("xproductmatch") = "Yes" then
      '6.50 - enhanced productmatching
      catsql = catsql & " and "
      Generateproductmatchsqlsubscat catsql
   end if

   '700 - Customer Groups - Matching Custormer match
   catsql = catsql & GenerateCustomerMatchSQL ("customermatch","excustomermatch","loggedin","and")

   if GetConfig("xselectproductsbylanguage") = "Yes" and GetSess("language")<>"" then
      '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      catsql = catsql & " and (catlanguage="& sqlserverprefixn &"'" & GetSess("language") & "'"
      catsql = catsql & " or catlanguage is null)"
   end if

   '6.08 - Order by config option rather than hardcoded
   catSQL = catsql & " order by " & GetConfig("xsortcategories")
   Set catrs = Server.CreateObject("ADODB.Recordset")

   '700 - 2010.08.24 - Enhancement: Speed up initial loading time
   'catrs.open catsql, dbc, adOpenDynamic, adLockOptimistic
   ShopOpenRecordSet catsql, catrs, 9999, 1

   while not catrs.eof
      cid = catrs("categoryid")
      name = catrs("catdescription")
      if isnull(name) then name = ""
      name = TranslateLanguage(dbc, "categories", "catdescription", "categoryid", cid, name)
      hassubcategory = catrs("hassubcategory")
      if isnull(hassubcategory) then
         hassubcategory = ""
      end if
      if hasSubcategory = "" then
         mylink = "<a href=""shopdisplayproducts.asp?id=" & cid & "&amp;cat=" & Server.URLEncode(replace(name,"&amp;","&")) & addwebsesslink & """>" & name & "</a>"
		 '700 - SEO
	     genseocategoryproductlink mylink,catrs("categoryid"),name,name,hasSubcategory,"Yes"
      else
	     if lcase(itype) = "dropdown" then
            mylink = "<a href=""javascript:toggleMe('catnavcid"& cid &"')"">" & name & "...</a>"
         else
		    mylink = "<a href=""shopdisplaycategories.asp?id=" & cid & "&amp;cat=" & Server.URLEncode(replace(name,"&amp;","&")) & addwebsesslink & """>" & name & "...</a>"
		    '700 - SEO
	        genseocategoryproductlink mylink,catrs("categoryid"),name,name,hasSubcategory,"Yes"
		 end if
	     generatesublinks cid,mylink2,itype
		 if lcase(itype) = "dropdown" then
		    mylink = mylink & "<div id=""catnavcid"& cid &""" style=""display:none"" class=""submenulist"">" & mylink2 & "</div>"
		 else
			'700 - 2010.05.31 - Enhancement: Category Flyout issue with browser IE6 and W3C
			mylink = mylink & mylink2
		 end if
      end if

      categories(catcount) = mylink
      catcount = catcount + 1
      catrs.MoveNext
   wend
   '700 - 2010.05.03 - Check all databasae must close after opened.
   closerecordset catrs
   
   plink=""
   if catcount > 0 then
      '700 - 2010.05.31 - Enhancement: Category Flyout issue with browser IE6 and W3C
      if lcase(itype) <> "flyout" then
         plink = plink & "<ul class=""menulist"">"
      else
	     plink = plink & "<ul>"
	  end if
      for i = 0 to catcount -1
         plink = plink & "<li>"
         plink = plink & categories(i)
	     plink = plink & "</li>"
      next
      plink = plink & "</ul>"
   end if
   exit sub
end sub

'Displays stylesheet driven menu
sub NavigateShowCategoriesStyled(itype,containerdivname)
   if GetConfig("Xnavigatecategories") = "No" then exit sub
   if GetConfig("xlogonrequired") = "Yes" then
      if GetSess("login") = "" then
         exit sub
      end if
   end if
   if GetConfig("init") = "" then exit sub
   dim cid, name, catSQL, i
   dim strcategory, catcount, categories, maxcategories
   dim catrs, hassubcategory, mylink
   
   '700 - Category Menu Enhancements
   dim mylink2
   
   if catcount = "" then catcount = 0

   '6.50 - advanced session handling
   '700 - 2010.06.10 - Enhancement: Better session handling while using xsavesession
   if lcase(xsavesession) = "yes" then
      catcount = 0
   end if

   if catcount = 0 then
      catcount = 0
      maxcategories = GetConfig("xmaxcategories")
      redim categories(maxcategories)
      catSQL = "Select * from categories where highercategoryid=0 and cathide is null "
      if GetConfig("xproductmatch") = "Yes" then
         '6.50 - enhanced productmatching
         catsql = catsql & " and "
         Generateproductmatchsqlsubscat catsql
      end if
	  
	  '700 - Customer Groups - Matching Custormer match
	  catsql = catsql & GenerateCustomerMatchSQL ("customermatch","excustomermatch","loggedin","and")
	  
      if GetConfig("xselectproductsbylanguage") = "Yes" and GetSess("language")<>"" then
	     '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
         catsql = catsql & " and (catlanguage="& sqlserverprefixn &"'" & GetSess("language") & "'"
         catsql = catsql & " or catlanguage is null)"
      end if
      '6.08 - Order by config option rather than hardcoded
      catSQL = catsql & " order by " & GetConfig("xsortcategories")

      Set catrs = Server.CreateObject("ADODB.Recordset")
      
	  '700 - 2010.08.24 - Enhancement: Speed up initial loading time
      'catrs.open catsql, dbc, adOpenDynamic, adLockOptimistic
	  ShopOpenRecordSet catsql, catrs, 9999, 1
	  
      while not catrs.eof and catcount<maxcategories
         cid = catrs("categoryid")
         name = catrs("catdescription")
         if isnull(name) then name = ""
         name = TranslateLanguage(dbc, "categories", "catdescription", "categoryid", cid, name)
         hassubcategory = catrs("hassubcategory")
         if isnull(hassubcategory) then
            hassubcategory = ""
         end if
         if hasSubcategory = "" then
            mylink = "<a href=""shopdisplayproducts.asp?id=" & cid & "&amp;cat=" & Server.URLEncode(replace(name,"&amp;","&")) & addwebsesslink & """>" & name & "</a>"
		    '700 - SEO
	        genseocategoryproductlink mylink,catrs("categoryid"),name,name,hasSubcategory,"Yes"
         else
		    '700 - Category Menu Enhancements
			if lcase(itype) = "dropdown" then
			   mylink = "<a href=""javascript:toggleMe('"& containerdivname &"catnavcid"& cid &"')"" >" & name & "...</a>"
            else
			   mylink = "<a href=""shopdisplaycategories.asp?id=" & cid & "&amp;cat=" & Server.URLEncode(replace(name,"&amp;","&")) & addwebsesslink & """>" & name & "...</a>"
	   	       '700 - SEO
	           genseocategoryproductlink mylink,catrs("categoryid"),name,name,hasSubcategory,"Yes"
			end if
			generatesublinks cid,mylink2,itype
			if lcase(itype) = "dropdown" then
			   mylink = mylink & "<div id="""& containerdivname &"catnavcid"& cid &""" style=""display:none"" class=""submenulist"">" & mylink2 & "</div>"
			else
			   '700 - 2010.05.31 - Enhancement: Category Flyout issue with browser IE6 and W3C
			   mylink = mylink & mylink2
			end if
         end if
         categories(catcount) = mylink
         catcount = catcount + 1
         catrs.MoveNext
      wend
      SetSessA "categories", categories
      SetSess "catcount", catcount
      '700 - 2010.05.03 - Check all databasae must close after opened.
      closerecordset catrs
   end if

   catcount = GetSess("catcount")
   categories = GetSessa("categories")
   '6.50 - modified to use list instead of table
   if lcase(itype) = "dropdown" then
      htmlwrite "<ul class=""menulist"">"
   else
	  '700 - 2010.05.31 - Enhancement: Category Flyout issue with browser IE6 and W3C
	  htmlwrite "<ul id=""flyout"& flyout1counter &""">"
   end if

   for i = 0 to catcount -1
      mylink = categories(i)
%>
  <li>
    <%
      response.write mylink
%>
  </li>
  <%
   next
%>
</ul>
<%
   exit sub
end sub

' MiniCart
' Create mini cart
' If passed value "SHORT" it creates a small mini cart
sub NavigateShowMiniCart (itype)
   '5.00
   dim showtype
   showtype = ucase(itype)
   dim scartItem, ArrCart, displayprice
   dim dualtotal, dualsubtotal, dualprice
   dim totalquantity, totalproductquantity
   dim i, CartFields, total, subtotal, name, quantity, price
   scartItem = GetSess("CartCount")
   ArrCart = GetSessA("CartArray")
   
   '700 - 2010.07.20 - Enhancement: Better cartcount databae session handling
   if trim(scartitem) = "" then exit sub
   if cstr(scartitem) = "0" then exit sub
   dim hideprice

   hideprice = false
   if GetConfig("xdisplayprices") <> "Yes" then
      hideprice = true
   end if
   if GetConfig("xpriceloggedinonly") = "Yes" then
      if GetSess ("login") = "" then
         hideprice = true
      end if
   end if

   if GetConfig("Xnavigateminicart") = "No" then exit sub
   if showtype<>"SHORT" then
      HtmlWrite Minitable
      HtmlWrite MiniTitleRow
      HtmlWrite MiniNameTitleColumn & minititlefont & GetLang("langProductDescription") & "</span>" & Minifontend
      HtmlWrite MiniPriceColumn & minititlefont & GetLang("langProductQuantity") & "</span>" & Minifontend
      if hideprice <> true then
         HtmlWrite MiniPriceColumn & minititlefont & GetLang("langProductPrice") & "</span>" & Minifontend
         HtmlWrite MiniPriceColumn & minititlefont & GetLang("langProductTotal") & "</span>" & Minifontend
         if GetConfig("xdualprice") = "Yes" then
            HtmlWrite MiniPriceColumn & minititlefont & GetLang("langDualPrice") & "</span>" & Minifontend
            HtmlWrite MiniPriceColumn & minititlefont & GetLang("langDualTotal") & "</span>" & Minifontend
         end if
      end if
      HtmlWrite "</tr>"
   end if

   total = 0
   totalquantity = scartitem
   totalproductquantity = 0
   for i = 1 to scartItem
      '700 - 2010.08.09 - Enhancement: Not diplaying bundle-children products at minicart
      if trim(ArrCart(cbundleparentid, i)) = "" then
	  
      Quantity = ArrCart(cQuantity, i)
      Price = ArrCart(cUnitPrice, i)
      dualprice = ArrCart(cdualPrice, i)
      if dualprice = "" then dualprice = 0
      name = ArrCart(cProductMiniName, i)
      if name = "" then
         name = ArrCart(cProductName, i)
      end if
      name = TranslateLanguage(dbc, "products", "cname", "CatalogId", ArrCart(cProductid, i), name)

      subtotal = quantity * price
      dualsubtotal = quantity * dualprice
      Total = total + subtotal
      dualtotal = dualtotal + dualsubtotal
      totalproductquantity = totalproductquantity + quantity
      if showtype<>"SHORT" then
         Price = ShopFormatCurrency(price, GetConfig("xdecimalpoint"))
         HtmlWrite minirow
         HtmlWrite MiniNameColumn & Minifont & name & minicolumnend
         HtmlWrite MiniPricecolumn & MiniFont & quantity & minicolumnend
         if hideprice <> true then
            HtmlWrite MiniPriceColumn & MiniFont & Price & minicolumnend
            HtmlWrite MiniPriceColumn & Minifont & ShopFormatCurrency(subtotal, GetConfig("xdecimalpoint")) & minicolumnend
            if GetConfig("xdualprice") = "Yes" then
               dualPrice = formatnumber(dualprice, GetConfig("xdecimalpoint"))
               HtmlWrite MiniPriceColumn & MiniFont & dualPrice & minicolumnend
               HtmlWrite MiniPriceColumn & Minifont & ShopFormatDualCurrency(dualsubtotal, GetConfig("xdecimalpoint")) & minicolumnend
            end if
         end if
         HtmlWrite "</tr>"
      end if
	  
      '700 - 2010.08.09 - Enhancement: Not diplaying bundle-children products at minicart
      end if
   next
   if showtype = "SHORT" then
      HtmlWrite MinitableShort
      HtmlWrite MinititleRow
      HtmlWrite MiniPriceColumn & minifont & GetLang("langProductQuantity") & Minifontend
      if hideprice <> True then
         HtmlWrite MiniPriceColumn & minifont & GetLang("langProductPrice") & "</span>" & Minifontend
      end if
      HtmlWrite "</tr>"
      HtmlWrite minirow
      HtmlWrite MinipriceColumn & Minifont & totalproductquantity & Minicolumnend
      if hideprice <> true then
         HtmlWrite MinipriceColumn & minifont & ShopFormatCurrency(total, GetConfig("xdecimalpoint")) & Minicolumnend
      end if
   else
      if hideprice <> true then
         HtmlWrite "<tr><td>" & minifont & "<span class='fontbold'>" & GetLang("langMiniexcludes") & "</span>" & minicolumnend & "<td></td>"
         HtmlWrite MiniPricecolumn & minifont & minifontend
         HtmlWrite MiniPriceColumn & minifont & ShopFormatCurrency(total, GetConfig("xdecimalpoint")) & minifontend
         if GetConfig("xdualprice") = "Yes" then
            HtmlWrite "<td></td>" & MiniPriceColumn & minifont & ShopFormatDualCurrency(dualtotal, GetConfig("xdecimalpoint")) & minifontend
         end if
      end if
   end if
   HtmlWrite "</tr></table>"
   if GetConfig("xcurrencylink") = "Yes" then
      dim url, cprice
      cprice = ShopFormatNumber(total, GetConfig("xdecimalpoint"))
      url = "http://www.x-rates.com/cgi-bin/cgicalc.cgi?value=" & cprice & "&base=" & GetConfig("Xcurrencybase")
      HtmlWrite "<br /><a href=""" & url & """ target=""_blank"">" & "Convert " & GetConfig("xcurrencybase") & " " & cprice & "</a></span>"
   end if
end sub

' 6.00
' formats the minicart in the right menu
' Added functionality to remove extended display when "short" option is passed
' Michael - 11 Jan 2006
sub NavigateShowMiniCartRight (itype)
   dim showtype, sqlmininav
   showtype = ucase(itype)
   dim scartItem, ArrCart, displayprice
   dim dualtotal, dualsubtotal, dualprice
   dim totalquantity, totalproductquantity
   dim i, CartFields, total, subtotal, name, quantity, price, URLCart
   scartItem = GetSess("CartCount")
   ArrCart = GetSessA("CartArray")
   
   '700 - 2010.07.20 - Enhancement: Better cartcount databae session handling
   if (trim(scartitem) = "") or (cstr(scartitem) = "0") then
      response.write GetLang("langcartisempty")
      exit sub
   end if
   dim hideprice

   hideprice = false
   if GetConfig("xdisplayprices") <> "Yes" then
      hideprice = true
   end if
   if GetConfig("xpriceloggedinonly") = "Yes" then
      if GetSess ("login") = "" then
         hideprice = true
      end if
   end if

   if GetConfig("Xnavigateminicart") = "No" then exit sub
   if showtype<>"SHORT" then
      if hideprice <> true then
         if GetConfig("xdualprice") = "Yes" then
         end if
      end if
   end if

   total = 0
   totalquantity = scartitem
   totalproductquantity = 0
   dim cartcountwithoutbundle
   cartcountwithoutbundle = 0
   cartcountwithoutbundle = scartItem

   '700 - 2010.06.11 - Enhancement: Show parent catalogid at minicart
   dim inventoryhigherCatalogId
   inventoryhigherCatalogId = ""

   for i = 1 to scartItem
      '700 - 2010.08.09 - Enhancement: Not diplaying bundle-children products at minicart
      if trim(ArrCart(cbundleparentid, i)) <> "" then
	     cartcountwithoutbundle = cartcountwithoutbundle - 1
	  '700 - 2010.08.09 - Enhancement: Not diplaying bundle-children products at minicart
	  else
	  
      Quantity = ArrCart(cQuantity, i)
      Price = ArrCart(cUnitPrice, i)
      dualprice = ArrCart(cdualPrice, i)
      if dualprice = "" then dualprice = 0
      name = ArrCart(cproductname, i)
      URLCart = ArrCart(cproductid, i)
      if len(name)>50 then
         name = mid(name, 1, 50)
      end if

      sqlmininav = "select CatalogId, higherCatalogId, cname from products where CatalogId = " & URLCart
	  '700 - 2010.05.03 - Check all databasae must close after opened.
      dim namers, cname, pname, namers2
      Set namers = Server.CreateObject("ADODB.Recordset")
      '700 - 2010.09.26 - Enhancement: Speed up front store performance
	  '701 - 2011.03.15 - Enhancement: Speed up store performance
      namers.open sqlmininav, dbc, adOpenForwardOnly, adLockReadOnly
      if not namers.eof then
         if namers("higherCatalogId") > "" then
		    '700 - 2010.06.11 - Enhancement: Show parent catalogid at minicart
		    inventoryhigherCatalogId = namers("higherCatalogId")

            cname = namers("cname")
            cname = TranslateLanguage(dbc, "products", "cname", "CatalogId", namers("CatalogId"), cname)

            '6.08a - Change variable SQL to SQLMININAV
            sqlmininav = "select CatalogId, cname from products where CatalogId = " & namers("higherCatalogId")
			'700 - 2010.05.03 - Check all databasae must close after opened.
            Set namers2 = Server.CreateObject("ADODB.Recordset")
            '700 - 2010.09.26 - Enhancement: Speed up front store performance
			'701 - 2011.03.15 - Enhancement: Speed up store performance
            namers2.open sqlmininav, dbc, adOpenForwardOnly, adLockReadOnly
            if not namers2.eof then
               pname = namers2("cname")
               pname = TranslateLanguage(dbc, "products", "cname", "CatalogId", namers2("CatalogId"), pname)
               name = pname & " - " & cname
            else
               name = TranslateLanguage(dbc, "products", "cname", "CatalogId", ArrCart(cProductid, i), name)
            end if
			CloseRecordSet namers2
         else
            '700 - 2010.06.11 - Enhancement: Show parent catalogid at minicart
            inventoryhigherCatalogId = ""

            name = TranslateLanguage(dbc, "products", "cname", "CatalogId", ArrCart(cProductid, i), name)
         end if
      else
         name = TranslateLanguage(dbc, "products", "cname", "CatalogId", ArrCart(cProductid, i), name)
      end if
      CloseRecordSet namers

	  subtotal = quantity * price
      dualsubtotal = quantity * dualprice
      total = total + subtotal
      dualtotal = dualtotal + dualsubtotal
      totalproductquantity = totalproductquantity + quantity
      Price = ShopFormatCurrency(price, GetConfig("xdecimalpoint"))

      if showtype<>"SHORT" then
%>
<table width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="vt"><%=quantity%></td>
    <td class="vt"><%
         dim exdsql, exdrs
         exdsql = "select cdescurl from products where CatalogId = " & ArrCart(cProductid, i)
         Set exdrs = Server.CreateObject("ADODB.Recordset")
         '700 - 2010.09.26 - Enhancement: Speed up front store performance
		 '701 - 2011.03.15 - Enhancement: Speed up store performance
         exdrs.open exdsql, dbc, adOpenForwardOnly, adLockReadOnly
         if not exdrs.eof then
            '6.50 - go to shopquery.asp if it is set in the config
            if ucase(GetConfig("xCrossLinkurl")) = "SHOPEXD.ASP" then
               strDescurl = "shopexd.asp?id="
            else
               strDescurl = "shopquery.asp?CatalogId="
            end if
         end if
         CloseRecordSet exdrs

         if isnull(strDescurl) then
            strdescurl = ""
         end if

         if strDescURL<>"" then
            if GetConfig("xAddCatalogId") = "Yes" then
               '6.08a - added bc=no to stop breadcrumb appearing in page
               '6.50 - go to correct URL
               '6.50 - advanced session handling
  		   	   '700 - 2010.06.11 - Enhancement: Show parent catalogid at minicart
			   if trim(inventoryhigherCatalogId) <> "" then
			      strDescURL = strDescURL & inventoryhigherCatalogId & "&amp;bc=no" & addwebsesslink
			   else
			      strDescURL = strDescURL & ArrCart(cProductid, i) & "&amp;bc=no" & addwebsesslink
			   end if
            end if
         else
            if GetConfig("xGenerateShopexdLink") = "Yes" then
               strdescurl = "shopexd.asp"
               '6.08a - added bc=no to stop breadcrumb appearing in page
               '6.50 - go to correct URL
               '6.50 - advanced session handling
		   	   '700 - 2010.06.11 - Enhancement: Show parent catalogid at minicart
			   if trim(inventoryhigherCatalogId) <> "" then
			      strDescURL = strDescURL & inventoryhigherCatalogId & "&amp;bc=no" & addwebsesslink
			   else
			      strDescURL = strDescURL & ArrCart(cProductid, i) & "&amp;bc=no" & addwebsesslink
			   end if
               '700 - SEO
               genseoproductlink strDescURL,ArrCart(cProductid, i),"","No"
			   if getconfig("xSEODynamicEnable") = "Yes" and getconfig("xSEODynamicProductsEnable") = "Yes" then
			      strDescURL = strDescURL & "?bc=no" & addwebsesslink
			   end if
            end if
         end if

         if strdescurl > "" then
%>
      <a class="cartminilinks" href="<%=strDescURL%>"><%=name%></a></td>
    <%
	      else%>
    <%=name%>
    <%
	      end if%>
  </tr>
  <tr>
    <td class="vt">&nbsp;</td>
    <td class="vt"><%
         if hideprice <> true then
            if GetConfig("xdualprice") = "Yes" then
               dualPrice = formatnumber(dualprice, GetConfig("xdecimalpoint"))
%>
      <table width="100%" cellpadding="2" cellspacing="0">
        <tr>
          <td class="vt al"><%=Price%></td>
          <td class="vt ar"><%=ShopFormatDualCurrency(dualsubtotal,GetConfig("xdecimalpoint"))%></td>
        </tr>
      </table>
      <%
               else
                  response.write Price
              end if
           end if
%></td>
  </tr>
</table>
<br />
<%
      end if

      '700 - 2010.08.09 - Enhancement: Not diplaying bundle-children products at minicart
	  end if
   next

   if showtype<>"SHORT" then
      HtmlWrite "</td></tr><tr><td class=""cartsubtotalminicart"">"
      HtmlWrite "<hr />"
   end if
   if hideprice <> true then
      if showtype = "SHORT" then
         'HtmlWrite GetLang("langcart01") & scartItem & "<br/>"
		 HtmlWrite GetLang("langcart01") & cartcountwithoutbundle & "<br/>"
      end if
      HtmlWrite GetLang("langcommonsubtotal") & ": " & ShopFormatCurrency(total, GetConfig("xdecimalpoint")) & vbcrlf
      if GetConfig("xdualprice") = "Yes" then
         HtmlWrite ShopFormatDualCurrency(dualtotal, GetConfig("xdecimalpoint"))
      end if
   end if
   '6.50 - advanced session handling
   HtmlWrite "<br /><a href='shopaddtocart.asp" & addwebsesslinkfirst & "'>" & GetLang("langcommonviewcart") & "</a>&nbsp;|" & vbcrlf
   HtmlWrite "&nbsp;<a href='shopcustomer.asp" & addwebsesslinkfirst & "'>" & GetLang("langcommoncheckout") & "</a>" & vbcrlf

   '6.09 - add currency link to bottom of minicart
   if GetConfig("xcurrencylink") = "Yes" then
      dim url, cprice
      cprice = ShopFormatNumber(total, GetConfig("xdecimalpoint"))
      url = "http://www.x-rates.com/cgi-bin/cgicalc.cgi?value=" & cprice & "&base=" & GetConfig("Xcurrencybase")
      HtmlWrite "<br /><a href=""" & url & """ target=""_blank"">" & "Convert " & GetConfig("xcurrencybase") & " " & cprice & "</a></span>"
   end if
end sub

'css styled minicart
sub NavigateShowMiniCartCssStyled
   htmlwrite "<div class=""contentcell"">"

   dim scartItem, ArrCart
   scartItem = GetSess("CartCount")
   ArrCart = GetSessA("CartArray")
   if (cstr(scartitem) = "") or (cstr(scartitem) = "0") then
      setsess "CartCount", 0
      htmlwrite "<span class=""message"">"
      response.write GetLang("langcartisempty")
	  htmlwrite "</span>"
	  htmlwrite "</div>"
      exit sub
   end if
   
   htmlwrite "<ul class=""minicart"">"   
   dim hideprice
   hideprice = false
   if GetConfig("xdisplayprices") <> "Yes" then
      hideprice = true
   end if
   if GetConfig("xpriceloggedinonly") = "Yes" then
      if GetSess ("login") = "" then
         hideprice = true
      end if
   end if

   if GetConfig("Xnavigateminicart") = "No" then exit sub

   dim sqlmininav
   dim displayprice
   dim dualtotal, dualsubtotal, dualprice
   dim totalquantity, totalproductquantity
   dim i, CartFields, total, subtotal, name, quantity, price, URLCart
   dim exdsql, exdrs

   total = 0
   totalquantity = scartitem
   totalproductquantity = 0
   dim cartcountwithoutbundle
   cartcountwithoutbundle = 0
   cartcountwithoutbundle = scartItem

   '700 - 2010.06.11 - Enhancement: Show parent catalogid at minicart
   dim inventoryhigherCatalogId
   inventoryhigherCatalogId = ""

   for i = 1 to scartItem
      '700 - 2010.08.09 - Enhancement: Not diplaying bundle-children products at minicart
      if trim(ArrCart(cbundleparentid, i)) <> "" then
	     cartcountwithoutbundle = cartcountwithoutbundle - 1
	  '700 - 2010.08.09 - Enhancement: Not diplaying bundle-children products at minicart
	  else
	  
      Quantity = ArrCart(cQuantity, i)
      Price = ArrCart(cUnitPrice, i)
      dualprice = ArrCart(cdualPrice, i)
      if dualprice = "" then dualprice = 0
      
	  '701 - 2011.07.13 - Enhancement: Better handling on displaying cname at minicart
	  name = CMSRemoveHTML(replace(ArrCart(cproductname, i),"<br />",chr(13)))
	  
      URLCart = ArrCart(cproductid, i)
      if len(name)>50 then
         name = mid(name, 1, 50)
      end if

      sqlmininav = "select CatalogId, higherCatalogId, cname from products where CatalogId = " & URLCart
	  '700 - 2010.05.03 - Check all databasae must close after opened.
      dim namers, cname, pname, namers2
	  on error resume next
      Set namers = Server.CreateObject("ADODB.Recordset")
	  '700 - 2010.09.26 - Enhancement: Speed up front store performance
	  '701 - 2011.03.15 - Enhancement: Speed up store performance
      namers.open sqlmininav, dbc, adOpenForwardOnly, adLockReadOnly
      if not namers.eof then
         if namers("higherCatalogId") > "" then
		    '700 - 2010.06.11 - Enhancement: Show parent catalogid at minicart
		    inventoryhigherCatalogId = namers("higherCatalogId")

            cname = namers("cname")
            cname = TranslateLanguage(dbc, "products", "cname", "CatalogId", namers("CatalogId"), cname)

            '6.08a - Change variable SQL to SQLMININAV
            sqlmininav = "select CatalogId, cname from products where CatalogId = " & namers("higherCatalogId")
            '700 - 2010.05.03 - Check all databasae must close after opened.
            Set namers2 = Server.CreateObject("ADODB.Recordset")
            '700 - 2010.09.26 - Enhancement: Speed up front store performance
			'701 - 2011.03.15 - Enhancement: Speed up store performance
            namers2.open sqlmininav, dbc, adOpenForwardOnly, adLockReadOnly
            if not namers2.eof then
               pname = namers2("cname")
               pname = TranslateLanguage(dbc, "products", "cname", "CatalogId", namers2("CatalogId"), pname)
               name = pname & " - " & cname
            else
               name = TranslateLanguage(dbc, "products", "cname", "CatalogId", ArrCart(cProductid, i), name)
			   pname = namers2("cname")
            end if
			CloseRecordSet namers2
         else
            '700 - 2010.06.11 - Enhancement: Show parent catalogid at minicart
            inventoryhigherCatalogId = ""

            name = TranslateLanguage(dbc, "products", "cname", "CatalogId", ArrCart(cProductid, i), name)
			pname = namers("cname")
         end if
      else
         name = TranslateLanguage(dbc, "products", "cname", "CatalogId", ArrCart(cProductid, i), name)
		 pname = name
      end if
      CloseRecordSet namers

	  subtotal = quantity * price
      dualsubtotal = quantity * dualprice
      total = total + subtotal
      dualtotal = dualtotal + dualsubtotal
      totalproductquantity = totalproductquantity + quantity
      Price = ShopFormatCurrency(price, GetConfig("xdecimalpoint"))

	  htmlwrite "<li>"
	  htmlwrite "<span>"& quantity &"</span>"
	  htmlwrite "<div>"

      exdsql = "select cdescurl from products where CatalogId = " & ArrCart(cProductid, i)
      Set exdrs = Server.CreateObject("ADODB.Recordset")
      '700 - 2010.09.26 - Enhancement: Speed up front store performance
	  '701 - 2011.03.15 - Enhancement: Speed up store performance
      exdrs.open exdsql, dbc, adOpenForwardOnly, adLockReadOnly
      if not exdrs.eof then
         '6.50 - go to shopquery.asp if it is set in the config
         if ucase(GetConfig("xCrossLinkurl")) = "SHOPEXD.ASP" then
            strDescurl = "shopexd.asp?id="
         else
            strDescurl = "shopquery.asp?CatalogId="
         end if
      end if
      CloseRecordSet exdrs

      if isnull(strDescurl) then
         strdescurl = ""
      end if

      if strDescURL<>"" then
         if GetConfig("xAddCatalogId") = "Yes" then
            '6.08a - added bc=no to stop breadcrumb appearing in page
            '6.50 - go to correct URL
            '6.50 - advanced session handling
			'700 - 2010.06.11 - Enhancement: Show parent catalogid at minicart
			if trim(inventoryhigherCatalogId) <> "" then
			   strDescURL = strDescURL & inventoryhigherCatalogId & "&amp;bc=no" & addwebsesslink
			else
			   strDescURL = strDescURL & ArrCart(cProductid, i) & "&amp;bc=no" & addwebsesslink
			end if
         end if
      else
         if GetConfig("xGenerateShopexdLink") = "Yes" then
		    '700 - 2010.09.15 - Bug Fix: Gift catalagid link wrongly show at side minicart after adding to cart
            strdescurl = "shopexd.asp?id="
			
            '6.08a - added bc=no to stop breadcrumb appearing in page
            '6.50 - go to correct URL
            '6.50 - advanced session handling
			'700 - 2010.06.11 - Enhancement: Show parent catalogid at minicart
			if trim(inventoryhigherCatalogId) <> "" then
			   strDescURL = strDescURL & inventoryhigherCatalogId & "&amp;bc=no" & addwebsesslink
			else
			   '700 - 2010.09.15 - Bug Fix: Gift catalagid link wrongly show at side minicart after adding to cart
			   if ArrCart(cProductid,i) = GetConfig("xgiftproductid") then
			      strDescURL = strDescURL & getsess("ordergiftproductid") & "&amp;bc=no" & addwebsesslink
			   else
			      strDescURL = strDescURL & ArrCart(cProductid, i) & "&amp;bc=no" & addwebsesslink
			   end if
			end if
			
            '700 - SEO
            genseoproductlink strDescURL,ArrCart(cProductid, i),"","No"
	        if getconfig("xSEODynamicEnable") = "Yes" and getconfig("xSEODynamicProductsEnable") = "Yes" then
			   strDescURL = strDescURL & "?bc=no" & addwebsesslink
			end if
			
			'701 - 2011.07.13 - Enhancement: Better handling on displaying cname at minicart
			if cstr(ArrCart(cProductid, i)) = cstr(getconfig("xprojectcatalogid")) then strDescURL = ""
         end if
      end if

      if strdescurl > "" then
	     htmlwrite "<a href="""& strDescURL &""">"& pname &"</a><br />"
      else
	     htmlwrite pname
	  end if

      if hideprice <> true then
         if GetConfig("xdualprice") = "Yes" then
            dualPrice = formatnumber(dualprice, GetConfig("xdecimalpoint"))
			response.write Price & "&nbsp;" & ShopFormatDualCurrency(dualsubtotal,GetConfig("xdecimalpoint"))
         else
            response.write Price
         end if
	  end if
	  htmlwrite "</div>"
	  htmlwrite "</li>"
	  
	  '700 - 2010.08.09 - Enhancement: Not diplaying bundle-children products at minicart
	  end if
   next
   htmlwrite "</ul>"

   if hideprice <> true then
      htmlwrite "<div class=""minicart-subtotal"">"&  GetLang("langcommonsubtotal") &": "& ShopFormatCurrency(total, GetConfig("xdecimalpoint")) &""
	  if GetConfig("xdualprice") = "Yes" then
	     htmlwrite ShopFormatDualCurrency(dualtotal, GetConfig("xdecimalpoint"))
	  end if
	  htmlwrite "</div>"

      '6.50 - advanced session handling
	  htmlwrite "<div class=""minicart-links""><a href=""shopaddtocart.asp" & addwebsesslinkfirst & """>"& GetLang("langcommonviewcart") &"</a>&nbsp;|&nbsp;<a href=""shopcustomer.asp" & addwebsesslinkfirst & """>"& GetLang("langcommoncheckout") &"</a></div>"

      '6.09 - add currency link to bottom of minicart
      if GetConfig("xcurrencylink") = "Yes" then
         dim url, cprice
         cprice = ShopFormatNumber(total, GetConfig("xdecimalpoint"))
         url = "http://www.x-rates.com/cgi-bin/cgicalc.cgi?value=" & cprice & "&base=" & GetConfig("Xcurrencybase")
		 htmlwrite "<div class=""minicart-links""><a href=""" & url & """ target=""_blank"">Convert " & GetConfig("xcurrencybase") & " " & cprice & "</a></div>"
      end if
   end if
   htmlwrite "</div>"
end sub

' creates quick go to categories
' currently used in shoppage_header.htm
sub NavigateShowAllCategories()
   if GetConfig("xlogonrequired") = "Yes" then
      if GetSess("login") = "" then
         exit sub
      end if
   end if
   if GetConfig("init") = "" then exit sub
   dim cid, name, catSQL, i
   dim strcategory, catcount, categories, maxcategories, categoryids, subcategories
   dim catrs, hassubcategory, mylink
   dim strpagename
   catcount = GetSess("allcatcount")
   if catcount = "" then catcount = 0
   if GetConfig("xtranslate") = "Yes" then
      catcount = 0
   end if
   if catcount = 0 then
      catcount = 0
      maxcategories = GetConfig("xmaxcategories")
      redim categories(maxcategories)
      redim categoryids(maxcategories)
      redim subcategories(maxcategories)
      if not dbc.state = adStateOpen then
         exit sub
      end if
      catSQL = "Select * from categories where cathide is null order by catdescription"
      Set catrs = Server.CreateObject("ADODB.Recordset")
      '700 - 2010.09.26 - Enhancement: Speed up front store performance
	  '701 - 2011.03.15 - Enhancement: Speed up store performance
      catrs.open catsql, dbc, adOpenForwardOnly, adLockReadOnly
      while not catrs.eof and catcount<maxcategories
         cid = catrs("categoryid")
         name = catrs("catdescription")
         name = TranslateLanguage(dbc, "categories", "catdescription", "categoryid", cid, name)
         hassubcategory = catrs("hassubcategory")
         if isnull(hassubcategory) then hassubcategory = ""
         categories(catcount) = name
         categoryids(catcount) = cid
         subcategories(catcount) = hassubcategory
         catcount = catcount + 1
         catrs.MoveNext
      wend
      SetSessA "allcategories", categories
      SetSessA "allcategoryids", categoryids
      SetSess "allcatcount", catcount
      SetSessA "allcatsubcategories", subcategories
      '700 - 2010.05.03 - Check all databasae must close after opened.
      closerecordset catrs
   end if
   dim optionval, category
   catcount = GetSess("allcatcount")
   categories = GetSessa("allcategories")
   categoryids = GetSessa("allcategoryids")
   subcategories = GetSessa("allcatsubcategories")
%>
<form name='catnavForm'>
  <select name="menu" onchange = "self.location = document.catnavForm.menu[document.catnavForm.menu.selectedIndex].value;" class="txtfielddropdown" size="1">
  <option selected><%=GetLang("langcat01")%></option>
  <%
   dim url, suffix

   for i = 0 to catcount -1
      cid = categoryids(i)
      category = categories(i)
      hassubcategory = subcategories(i)
      if hassubcategory<>"" then
         strPageName = "shopdisplaycategories.asp"
         suffix = "..."
      else
         strPageName = "shopdisplayproducts.asp"
         suffix = ""
      end if
      url = "" & strPageName & "?id=" & cid & "&cat=" & server.urlencode(category)
	  '700 - SEO
	  genseocategoryproductlink url,cid,category,category,hassubcategory,"No"
      url = addwebsess(url)
      response.write "<option value='" & url & "'>" & category & Suffix & "</option>" & vbcrlf
   next
   response.write "</select></form>"
end sub

'701 - 2011.02.15 - Enhancement on routine CorrectBooleanProgram
sub CorrectBooleanProgram (fieldvalue)
   'If it is yes set to 1 else set to 0
   if isnull(fieldvalue) or fieldvalue = "" then
      fieldvalue = 0
   end if
'   ' Dec 31, fix
'   if not isnumeric(fieldvalue) then
'      fieldvalue = 0
'   end if

   if fieldvalue = yesnos(1) then
      fieldvalue = 0
   end if

   if lcase(fieldvalue) = "true" or fieldvalue = true or lcase(fieldvalue) = "false" or fieldvalue = false then
      if lcase(fieldvalue)="true" or fieldvalue = true then
         fieldvalue = yesnos(0) ' Yes
      else
         fieldvalue = yesnos(1) ' no
      end if
   else
      if cstr(fieldvalue)<>"0" then
         fieldvalue = yesnos(0) ' Yes
      else
         fieldvalue = yesnos(1) ' no
      end if
   end If
end sub

sub CorrectBooleanHuman (fieldvalue)
   'If it is yes set to 1 else set to 0
   if fieldvalue = yesnos(0) then
      fieldvalue = 1
   else
      fieldvalue = 0
   end if
end sub

' Used in shipping calculation to get total weight including
' feature weight
' Get total weight of products
sub GetTotalProductWeight (dbc, totalWeight, totalfeatureweight)
   dim prodid, prodcode, prodname, Prodquantity, ProdPrice, prodweight
   dim rsitem, deliveryarray, deliverytype, prodfeatures
   dim i, calculate
   dim featureweight
   dim weight, shipsql

   '700 - 2010.08.03 - Enhancmenet: Better error handling at shpoproductsubs.asp
   scartItem = GetSess("CartCount")
   on error resume next
   if err.number <> 0 then
      dim scartItem,ArrCart
	  scartItem = GetSess("CartCount")
	  err.clear
   end if

   ArrCart = GetSessA("CartArray")
   totalweight = 0
   totalfeatureweight = 0
   ' go through all products
   for i = 1 to scartItem
      Calculate = True
      prodid = ArrCart(cProductid, i)
      prodcode = ArrCart(cProductCode, i)
      prodname = ArrCart(cProductname, i)
      Prodquantity = ArrCart(cQuantity, i)
      ProdPrice = ArrCart(cUnitPrice, i)
      ProdFeatures = ArrCart(cProductFeatures, i)
      Prodweight = ArrCart(cProductweight, i)
      DeliveryArray = ArrCart(cDelivery, i)
      if GetConfig("Xdeliveryshipping") = "Yes" and isarray(deliveryarray) then
         Deliverytype = Deliveryarray(dDeliveryType)
         if Deliveryarray(dDeliveryType)<>GetLang("langDeliverySelf") then
            Calculate = False
         end if
      end if
      if calculate = True then
         weight = prodweight
         if weight<>"" and isnumeric(weight) then
            weight = cdbl(weight)
         else
            weight = 0
         end if

         weight = weight * ProdQuantity
         TotalWeight = weight + totalweight
         if GetConfig("xfeatureweight") = "Yes" and prodfeatures<>"" then
            GetTotalfeatureweight dbc, prodid, prodfeatures, featureweight
         end if
         featureweight = featureweight * prodquantity
         totalfeatureweight = totalfeatureweight + featureweight
      end if
   next
   TotalWeight = totalweight + Totalfeatureweight
   SetSess "Totalweight", Totalweight
end sub

' features come in as a list 5,9,11
' reread the feature record and get weight from featureother1
sub GetTotalfeatureweight (dbc, prodid, prodfeatures, featureweight)
   dim sql, rs, tweight, totalweight, weight
   dim words(50), wordcount, i
   featureweight = 0
   if prodfeatures = "" then exit sub
   ParseRecord prodfeatures, words, wordcount, ","
   totalweight = 0
   for i = 0 to wordcount -1
      weight = 0
      sql = "select * from prodfeatures where id=" & words(i)
      Set rs = Server.CreateObject("ADODB.Recordset")
      '700 - 2010.09.26 - Enhancement: Speed up front store performance
	  '701 - 2011.03.15 - Enhancement: Speed up store performance
      rs.open sql, dbc, adOpenForwardOnly, adLockReadOnly
      if not rs.eof then
         tweight = rs("featureweight")
         if not isnull(tweight) then
            if isnumeric(tweight) then
               weight = cdbl(tweight)
            end if
         end if
      end if
      totalweight = totalweight + weight
      CloseRecordSet rs
   next
   featureweight = totalweight
end sub

' write login form for shopcustomer, shopcustadminlogin
sub ShopLOginForm_old
   dim caption
   if GetConfig("xcustomeruserid") = "Yes" then
      caption = GetLang("langAdminUsername")
   else
      caption = GetLang("langStatusEmail")
   end if
   if ucase(GetConfig("Xpassword")) = "YES" then
      htmlwrite "<form name=form1 method=Post action=shoplogin.asp>"

      '700 - 2010.04.22 - cross site script security enhancement
      htmlwrite "<input type=""hidden"" name=""genpredefinedsecuritycode"" value="""& session("genpredefinedsecuritycode") &""" />"

      htmlwrite TableDefLogin
      htmlwrite tablerow
      if ucase(GetConfig("xPasswordLastname")) = "YES" then
         htmlwrite tablecolumn & GetLang("langCustLastname") & tablecolumnend & "<td><input size=20 name=strLastname value=" & chr(34) & strLastname & chr(34) & "></td>"
      end if
      htmlwrite tablecolumn & caption & tablecolumnend & Tablecolumn & "<input size=20 name=strEmail>" & tablecolumnend
      htmlwrite tablecolumn & GetLang("langLoginPassword") & tablecolumnend & Tablecolumn & "<input size=10 type=password name=strPassword>" & tablecolumnend
      htmlwrite tablecolumn
      ShopButton GetConfig("xbuttonlogin"), GetLang("langcommonlogin"), ""
      htmlwrite Tablecolumnend
      htmlwrite "</tr></table>"
      addwebsessform
      htmlwrite "</form>"
      htmlwrite "<a href=shopmailpwd.asp?pwd=yes" & addwebsesslink & ">" & GetLang("langLoginForgot") & "</a>"
   else
      htmlwrite "<form name=form1 method=Post action=shoplogin.asp>"

      '700 - 2010.04.22 - cross site script security enhancement
      htmlwrite "<input type=""hidden"" name=""genpredefinedsecuritycode"" value="""& session("genpredefinedsecuritycode") &""" />"

      htmlwrite TableDefLogin
      htmlwrite tablerow & tablecolumn & GetLang("langCustLastname") & tablecolumnend & "<td><input size=20 name=strLastname value=" & chr(34) & strLastname & chr(34) & "></td>"
      htmlwrite tablecolumn & GetLang("langCustEmail") & tablecolumnend & "<td><input size=20 name=strEmail" & "></td>"
      htmlwrite tablecolumn
      ShopButton GetConfig("xbuttonlogin"), GetLang("langcommonlogin"), ""
      htmlwrite Tablecolumnend
      htmlwrite "</tr></table>"
      addwebsessform
      htmlwrite "</form>"
   end if
end sub

sub ShopLoginForm
   dim caption
   if GetConfig("xcustomeruserid") = "Yes" then
      caption = GetLang("langAdminUsername")
   else
      caption = GetLang("langStatusEmail")
   end if
%>
  <h1>
  <%=GetLang("langCust01")%>
  </h1>
  <div id="loginform">
  <img src="images/site/customerlogin.gif" class="iconlogin" alt=" " />

  <table width="100%" cellspacing="6" cellpadding="0" class="logintable">
  <tr>
  <!--6.08 - Translate titles and buttons-->
  <td class="al">
  <span class='fontbold'><%=GetLang("langlogin03")%></span>
  </td>
  <td class="al">
  <span class='fontbold'><%=GetLang("langcommonlogin")%></span>
  </td>
  </tr>
  <tr>
  <td class="dottedBorder vt al" width="50%">
  <%dim currentpage
   currentpage = request.ServerVariables("SCRIPT_NAME")
   currentpage = right(currentpage, len(currentpage) - instrrev(currentpage, "/"))

   if currentpage = "shopcustadminlogin.asp" then
      if GetConfig("xAllowcustomerregister") = "Yes" then
%>
  <%=GetLang("langnewcustomerregister01")%> <br />
  <br />
  <%'6.50 - allow button to be configurable using admin
         if GetConfig("xbuttonsignup") = "" then
%>
  <div align="right">
  <input type="button" class="submitbtn" value="<%=GetLang("langcommonsignup")%>" onclick="location.href='shopcustregister.asp'" />
  </div>
  <%
         else%>
  <div align="right">
  <input type="image" src="<%=GetConfig("xbuttonsignup")%>" value="<%=GetLang("langcommonsignup")%>" onclick="location.href='shopcustregister.asp'" />
  </div>
  <%
         end if%>
  <%
      end if
   else
%>
  <%=GetLang("langnewcustomerregister02")%> <br />
  <br />
  <%'6.50 - allow button to be configurable using admin
      if GetConfig("xbuttonsignup") = "" then
%>
  <div align="right">
  <input type="button" class="submitbtn" value="<%=GetLang("langcommonsignup")%>" onclick="location.href='shopcustomer.asp?new=yes'" />
  </div>
  <%
      else%>
  <div align="right">
  <input type="image" src="<%=GetConfig("xbuttonsignup")%>" value="<%=GetLang("langcommonsignup")%>" onclick="location.href='shopcustomer.asp?new=yes'" />
  </div>
  <%
      end if%>
  <%
   end if%>
  </td>
  <td class="dottedBorder vt al" width="50%">
  <%=GetLang("langreturningcustomers")%> <br />
  <%
   If ucase(GetConfig("Xpassword"))="YES" then %>
  <form name="form1" method="post" action="shoplogin.asp">
<%
'700 - 2010.04.22 - cross site script security enhancement
htmlwrite "<input type=""hidden"" name=""genpredefinedsecuritycode"" value="""& session("genpredefinedsecuritycode") &""" />"
%>
  <table cellpadding="2" cellspacing="1" border="0" width="100%">
  <% 
      If ucase(GetConfig("xPasswordLastname"))="YES" then %>
  <tr>
  <td width="30%">
  <%=GetLang("langCustLastname")%>
  </td>
  <td>
  <input class="txtfield" size="24" name="strLastname" value="<%=Chr(34) & strLastname & Chr(34)%>" />
  </td>
  </tr>
  <%
      end if %>
  <tr>
  <td width="30%">
  <%=caption%>
  </td>
  <td>
  <input class="txtfield" size="24" name="strEmail" />
  </td>
  </tr>
  <tr>
  <td width="30%">
  <%=GetLang("langLoginPassword")%>
  </td>
  <td>
  <input size="24" class="txtfield" type="password" name="strPassword" />
  </td>
  </tr>
  <tr>
  <td>
  &nbsp;
  </td>
  <td>
  <div align="right">
  <%ShopButton GetConfig("xbuttonlogin"),GetLang("langcommonlogin"),""%>
  </div>
  </td>
  </tr>
  </table>
  <% addwebsessform %>
</form>
<div class="ac"><a href="shopmailpwd.asp?pwd=yes<%addwebsesslink%>"><%=GetLang("langLoginForgot")%></a></div>
<%
   else %>
<form name="form1" method="post" action="shoplogin.asp">
<%
'700 - 2010.04.22 - cross site script security enhancement
htmlwrite "<input type=""hidden"" name=""genpredefinedsecuritycode"" value="""& session("genpredefinedsecuritycode") &""" />"
%>
  <table cellpadding="2" cellspacing="1" border="0" width="100%">
    <tr>
      <td width="30%"><%=GetLang("langCustLastname")%></td>
      <td><input class="txtfield" size="24" name="strLastname" value=<%=Chr(34) & strLastname & Chr(34)%>></td>
    </tr>
    <tr>
      <td width="30%"><%=GetLang("langCustEmail")%></td>
      <td><input size="24" class="txtfield" name=strEmail></td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td><div align="right">
          <%ShopButton GetConfig("xbuttonlogin"), GetLang("langcommonlogin"),""%>
        </div></td>
    </tr>
  </table>
  <%addwebsessform%>
</form>
<% 
   end if %>
</td>
</tr>
</table>
</div>
<%
end sub

' Display all products in a quick shop list
sub NavigateShowProducts
   dim rs, sql
%>
<form name='prodnavForm'>
<select name="menu" onchange = "self.location = document.prodnavForm.menu[document.prodnavForm.menu.selectedIndex].value;" class="txtfielddropdown" size="1">
<%
   sql = "SELECT * FROM products ORDER by CatalogId"
   Set rs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   '701 - 2011.03.15 - Enhancement: Speed up store performance
   rs.open sql, dbc, adOpenForwardOnly, adLockReadOnly
   do while not rs.eof '
%>
<option value="<%genredirecturl("shopaddtocart.asp?productid="& rs("CatalogId") &"&quantity=1")%>"> <%= rs("cname") %> </option>
<%
      rs.MoveNext
   loop
   response.write "</select></form>"
   CloseRecordSet rs
end sub

sub NavigateTopTen
   if GetConfig("xtopsellers") <> "Yes" then exit sub
   if GetConfig("xlogonrequired") = "Yes" then
      if GetSess("Login") = "" then
         exit sub
      end if
   end if
   if GetConfig("xshopclosed") = "Yes" then
      if GetSess("Login") = "Force" then
         exit sub
      end if
      if GetSess("shopadmin") = "" then
         ShopError GetLang("Langshopclosed")
      end if
   end if
   ' Find all products sold
   dim strsql, useorderdb
   dim rs

   strsql = "select o.CatalogId, sum(o.numitems) as sumofnumitems"
   strsql = strsql & " from oitems o "
   if GetConfig("xtopsellersprocessedonly") = "Yes" then
      if instr(ucase(xdatabasetype), "MYSQL") > 0 or instr(ucase(xdatabasetype), "SQLSERVER") > 0 then
         strsql = strsql & ", orders p WHERE o.orderid=p.orderid and p.oprocessed=1"
      else
         strsql = strsql & ", orders p WHERE o.orderid=p.orderid and p.oprocessed=TRUE"
      end if
   end if
   strsql = strsql & " GROUP BY o.CatalogId"
   if instr(ucase(xdatabasetype), "MYSQL") > 0 then
      strsql = strsql & " ORDER BY sumofnumitems DESC"
   else
      strsql = strsql & " ORDER BY sum(o.numitems) DESC"
   end if

   Set rs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   '701 - 2011.03.15 - Enhancement: Speed up store performance
   rs.open strsql, dbc, adOpenForwardOnly, adLockReadOnly

   '7.001 Move All Layout Elements To Template Files
   '700 - 2010.08.13 - Bug Fix: To cover the distinct with ntext type issue
   dim ptemplate
   ptemplate = getconfig("topsellertemplate")
   if trim(ptemplate) = "" then
      ptemplate = "tmp_topsellers.htm"
   end if

   '701 - 2011.01.12 - Enhancement: Speed up front store topseller
   dim odbc
   shopopendatabase odbc
   
   '700 - 2010.08.13 - Bug Fix: To cover the distinct with ntext type issue
   '701 - 2011.01.12 - Enhancement: Speed up front store topseller
   TopTenProducedetail odbc, rs, "TS", "", ptemplate

   CloseRecordSet rs
   
   '701 - 2011.01.12 - Enhancement: Speed up front store topseller
   shopclosedatabase odbc
end sub

'700 - home page manager
sub NavigateTopSeller (howmanyitems)
   if GetConfig("xtopsellers") <> "Yes" then exit sub
   if GetConfig("xlogonrequired") = "Yes" then
      if GetSess("Login") = "" then
         exit sub
      end if
   end if
   if GetConfig("xshopclosed") = "Yes" then
      if GetSess("Login") = "Force" then
         exit sub
      end if
      if GetSess("shopadmin") = "" then
         ShopError GetLang("Langshopclosed")
      end if
   end if
   
   if isnumeric(howmanyitems) = false then
      howmanyitems = 10
   else
      howmanyitems = int(howmanyitems)
   end if

   ' Find all products sold
   dim strsql, useorderdb
   dim rs

   strsql = "select o.CatalogId, sum(o.numitems) as sumofnumitems"
   strsql = strsql & " from oitems o "
   if GetConfig("xtopsellersprocessedonly") = "Yes" then
      if instr(ucase(xdatabasetype), "MYSQL") > 0 or instr(ucase(xdatabasetype), "SQLSERVER") > 0 then
         strsql = strsql & ", orders p WHERE o.orderid=p.orderid and p.oprocessed=1"
      else
         strsql = strsql & ", orders p WHERE o.orderid=p.orderid and p.oprocessed=TRUE"
      end if
   end if
   strsql = strsql & " GROUP BY o.CatalogId"
   if instr(ucase(xdatabasetype), "MYSQL") > 0 then
      strsql = strsql & " ORDER BY sumofnumitems DESC"
   else
      strsql = strsql & " ORDER BY sum(o.numitems) DESC"
   end if

   Set rs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   '701 - 2011.03.15 - Enhancement: Speed up store performance
   rs.open strsql, dbc, adOpenForwardOnly, adLockReadOnly

   '700 - 2010.08.13 - Bug Fix: To cover the distinct with ntext type issue
   '7.001 Move All Layout Elements To Template Files
   dim ptemplate
   ptemplate = getconfig("topsellertemplate")
   if trim(ptemplate) = "" then
      ptemplate = "tmp_topsellers.htm"
   end if
   
   '701 - 2011.01.12 - Enhancement: Speed up front store topseller
   dim odbc
   shopopendatabase odbc

   '700 - 2010.08.13 - Bug Fix: To cover the distinct with ntext type issue
   '701 - 2011.01.12 - Enhancement: Speed up front store topseller
   TopTenProducedetail odbc, rs, "TS", howmanyitems, ptemplate

   CloseRecordSet rs
   
   '701 - 2011.01.12 - Enhancement: Speed up front store topseller
   shopclosedatabase odbc
end sub

' Format the top ten products
' 6.08 - Sub re-written to hide out of stock products
'7.001 Move All Layout Elements To Template Files
'700 - 2010.08.13 - Bug Fix: To cover the distinct with ntext type issue
sub TopTenProduceDetail (dbc, rs, itype, ilimit, ptemplate)
   dim count, fieldvalue, prs, scriptresponder, filename, lngCatalogId, ordercount, hideprod
   dim strcname, strhcname, psql, lnghigherCatalogId
   dim limit

'700 - 2010.08.13 - Bug Fix: To cover the distinct with ntext type issue
'   '7.001 Move All Layout Elements To Template Files
'   dim ptemplate
'   if itype="TS" then
'      ptemplate = getconfig("topsellertemplate")
'	  if trim(ptemplate) = "" then
'         ptemplate = "tmp_topsellers.htm"
'      end if
'   else
'      ptemplate = getconfig("productfeaturestemplate")
'	  if trim(ptemplate) = "" then
'         ptemplate = "tmp_featuredproducts.htm"
'      end if
'   end if

   if ilimit <> "" then
      limit = ilimit
   else
      limit = cint(GetConfig("xtopsellerlimit"))
      if limit = "" or isnull(limit) then
         limit = 5
      end if
   end if
   count = 0
   
   if itype="TS" then
      setsess "homepagetsrecord",""
   else
      setsess "homepagefprecord",""
   end if
   
   '700 - 2010.06.18 - Enhancement: Not include sub-products to the products listings
   dim arylnghigherCatalogId(100)
   dim aryarylnghigherCatalogIdcnt
   dim calxcnt
   aryarylnghigherCatalogIdcnt = 0
   
   '701 - 2010.12.16 - xtopsellerparentonly is not working properly
   dim templimit,templimitcnt
   templimit = 99999
   templimitcnt = 0
   
   do while not rs.eof and count < templimit
      hideprod = false
      lngCatalogId = rs("CatalogId")
      ordercount = rs("sumofnumitems")
	  
      '701 - 2010.12.20 - Enhancement: Increase speed while generating topseller
	  psql = "select higherCatalogId from products where CatalogId = " & lngCatalogId
      Set prs = Server.CreateObject("ADODB.Recordset")
      '700 - 2010.09.26 - Enhancement: Speed up front store performance
	  '701 - 2011.03.15 - Enhancement: Speed up store performance
	  prs.open psql, dbc, adOpenForwardOnly, adLockReadOnly
      if not prs.eof then
         if prs("higherCatalogId") > "" then
            lnghigherCatalogId = prs("higherCatalogId")
         else
            lnghigherCatalogId = ""
         end if
      end if
      CloseRecordSet prs
	  
      '6.50 - added 'childhide' to sql below to stop hidden child products from showing
      if lnghigherCatalogId > "" then
         '6.50.4 Bugs Fix - 08 October 2008
         '701 - 2010.12.20 - Enhancement: Increase speed while generating topseller
		 psql = "select * from products p, prodcategories cc, categories c where p.CatalogId=" & lnghigherCatalogId
		 psql = psql & " and cc.intCatalogId=p.CatalogId and cc.intcategoryid=c.categoryid "
      else
         '701 - 2010.12.20 - Enhancement: Increase speed while generating topseller
		 psql = "select * from products p, prodcategories cc, categories c where p.CatalogId=" & lngCatalogId
         psql = psql & " and cc.intCatalogId=p.CatalogId and cc.intcategoryid=c.categoryid "
      end if

      '700 - generate sql by product criteria - 2010.04.03
      generateproductstdcriteriasql psql, "p.", "c.", "generateproductmatchsqlsubs"

      Set prs = Server.CreateObject("ADODB.Recordset")
      '700 - 2010.09.26 - Enhancement: Speed up front store performance
      prs.open psql, dbc, adOpenStatic, adLockOptimistic
      if not prs.eof then
         '6.50 - added 'childhide' to sql below to stop hidden child products from showing
'         if ((prs("hphide") = 1) or (lcase(prs("hphide")) = "true")) or ((prs("childhide") = 1) or (lcase(prs("childhide")) = "true")) then
'            hideprod = true
'         end if

'         if GetConfig("xstockcontrol") = "Yes" then
'            dim stocklowlevel
'            if GetConfig("xstocklow") = "" or isnull(GetConfig("xstocklow")) then
'               stocklowlevel = 0
'            else
'               stocklowlevel = GetConfig("xstocklow")
'            end if
'
'            '6.09 - If stockcontrol is on and the stock field of product was blank, there was an error here.
'            dim dbproductstock
'            dbproductstock = prs("cstock")
'            if isnull(dbproductstock) or dbproductstock = "" then
'               dbproductstock = 0
'            end if
'
'            if cint(dbproductstock) <= cint(stocklowlevel) then
'               hideprod = true
'            end if
'         end if
		 
		 '700 - 2010.06.18 - Enhancement: Not include sub-products to the products listings
		 if getconfig("xtopsellerparentonly") = "Yes" then
	  	    if trim(lnghigherCatalogId) <> "" then
  		       for calxcnt = 0 to aryarylnghigherCatalogIdcnt
		          if lnghigherCatalogId = arylnghigherCatalogId(calxcnt) then
			         hideprod = true
			         exit for
			      else
			         arylnghigherCatalogId(aryarylnghigherCatalogIdcnt) = lnghigherCatalogId
			         aryarylnghigherCatalogIdcnt = aryarylnghigherCatalogIdcnt + 1
					 '701 - 2010.12.16 - xtopsellerparentonly is not working properly
					 exit for
		   	      end if
		       next
		    end if
         end if

         '700 - featured products - slide show
         if itype="TS" then
            setsess "homepagetsrecord","yes"
         else
            setsess "homepagefprecord","yes"
         end if
         dim rc

         prs.movefirst

 	 	 '7.001 Move All Layout Elements To Template Files
		 '700 - 2010.06.18 - Enhancement: Not include sub-products to the products listings
		 '701 - 2010.12.16 - xtopsellerparentonly is not working properly
		 if not hideprod then
		    ShopTemplateWrite ptemplate, prs, rc
			templimitcnt = templimitcnt + 1
		 end if
         count = count + 1
      end if
      CloseRecordSet prs
	  
	  '701 - 2010.12.16 - xtopsellerparentonly is not working properly
	  if templimitcnt >= limit then
	     exit do
	  end if
	  
      rs.movenext
   loop
end sub

' create a list of letters with hyperlink to display products starting with
' those letters
' If your language has different characters please replace them in myarray
sub Navigateshowalphabet
   dim alphaarray(100), alphak, letters, alphacount
   if GetConfig("xalphabetdisplay")<>"Yes" then exit sub
   letters = GetConfig("xalphabet")
   if letters = "" then exit sub
   ParseRecord letters, alphaarray, alphacount, ","
   for alphak = 0 to alphacount -1
      response.write "<a href=""shopquery.asp?queryprefix=No&amp;cname=" & alphaarray(alphak) & addwebsesslink & """>" & alphaarray(alphak) & "</a>"
      response.write "&nbsp;"
   next
end sub

function GetProductOrderTotal
   dim Prodquantity, ProdPrice
   dim scartItem, ArrCart, total
   scartItem = GetSess("CartCount")
   ArrCart = GetSessA("CartArray")
   total = 0

   '700 - 2010.09.01 - Bug Fix: Possible error at GetProductOrderTotal routine
   dim i
   
   ' go through all products   
   for i = 1 to scartItem
      Prodquantity = ArrCart(cQuantity, i)
      ProdPrice = ArrCart(cUnitPrice, i)
      total = total + prodquantity * prodprice
   next
   SetSess "Productordertotal", Total
   GetProductOrderTotal = total
end function

function NavigateProducttotal
   dim i, stotal, iqtytotal
   dim ArrCart, cartcount
   dim Quantity
   iQtyTotal = 0
   stotal = 0
   ArrCart = GetSessA("CartArray")
   cartcount = GetSess("cartcount")
   for i = 1 to cartcount
      Quantity = ArrCart(cQuantity, i)
      sTotal = sTotal + Quantity * cdbl("0" & ArrCart(cUnitPrice, i))
      iQtyTotal = iQtyTotal + Quantity
   next
   navigateproducttotal = ShopFormatCurrency(sTotal, GetConfig("xdecimalpoint"))
end function

function NavigateProductQuantity
   dim i, stotal, qtytotal
   dim ArrCart, cartcount
   dim Quantity
   QtyTotal = 0
   ArrCart = GetSessA("CartArray")
   cartcount = GetSess("cartcount")
   for i = 1 to cartcount
      if ArrCart(cbundleparentid, i) = "" then
         Quantity = ArrCart(cQuantity, i)
         Qtytotal = Qtytotal + Quantity
	  end if
   next
   navigateproductquantity = QtyTotal
end function

function GenerateDateList (name, currentvalue, maxvalue, daysofweek, excludelist)
   dim i, j, count, downame, currentdate, displaypart
   dim value, dow, dayscount, daysarray(10)
   dim selected, excludes(10), excludecount
   ParseRecord daysofweek, daysarray, dayscount, ","
   if excludelist<>"" then
      ParseRecord excludelist, excludes, excludecount, ","
      for i = 0 to excludecount -1
         if not isnumeric(excludes(i)) then excludes(i) = 0
         excludes(i) = clng(excludes(i))
      next
   end if
   currentdate = currentvalue
   if not isdate(currentdate) then
      currentdate = date()
   else
      currentdate = cdate(currentdate)
   end if
   count = 0
   value = "<select name=""" & name & """>"
   do while maxvalue>count
      if currentdate = currentvalue then
         Selected = "selected=""selected"""
      else
         Selected = ""
      end if
      dow = weekday(currentdate)
      downame = daysarray(dow -1)
      if excludecount>0 then
         for j = 0 to excludecount -1
            if dow = (excludes(j)) then
               downame = ""
               exit for
            end if
         next
      end if
      if downame<>"" then
         count = count + 1
         Displaypart = currentdate & " " & downame
         value = value & "<option " & selected & " value=""" & currentdate & """>" & displaypart & "</option>"
      end if
      currentdate = currentdate+1
   loop
   value = value & "</select>"
   Generatedatelist = value
end function

' SQL injection Function
function GetTextField(fieldname)
   dim fieldvalue
   dim badchars, i

   '6.50 - precautionary security fix
   fieldvalue = CleanChars(request(fieldname))

   '6.50.4 - removed extra checking code - all done in CleanChars now
   GetTextField = fieldvalue
end function

' SQL injection Function
function GetIntField(fieldname)
   dim fieldvalue

   '6.50 - precautionary security fix
   fieldvalue = CleanChars(request(fieldname))

   if fieldvalue<>"" then
      if not isnumeric(fieldvalue) then
         fieldvalue = ""
      end if
   end if
   GetIntField = fieldvalue
end function

' Used in shipping calculation to get total weight including
' feature weight
' Get total weight of products
sub CalculateShippingdetails (dbc, totalWeight, totalfeatureweight, cost, quantity)
   dim prodid, prodcode, prodname, Prodquantity, ProdPrice, prodweight
   dim rsitem, deliveryarray, deliverytype, prodfeatures
   dim i, calculate
   dim featureweight
   dim weight, shipsql

   scartItem = GetSess("CartCount")
   ArrCart = GetSessA("CartArray")
   totalweight = 0
   totalfeatureweight = 0
   quantity = 0
   cost = 0

   ' go through all products
   for i = 1 to scartItem
      Calculate = True
      prodid = ArrCart(cProductid, i)

      prodcode = ArrCart(cProductCode, i)
      prodname = ArrCart(cProductname, i)
      Prodquantity = ArrCart(cQuantity, i)
      ProdPrice = ArrCart(cUnitPrice, i)
      ProdFeatures = ArrCart(cProductFeatures, i)
      Prodweight = ArrCart(cProductweight, i)
      calculate = checkdeliveryfree(dbc, prodid)
      if calculate = True then
         weight = prodweight
         if weight<>"" and isnumeric(weight) then
            weight = cdbl(weight)
         else
            weight = 0
         end if
         weight = weight * ProdQuantity
         TotalWeight = weight + totalweight
         if GetConfig("xfeatureweight") = "Yes" and prodfeatures<>"" then
            GetTotalfeatureweight dbc, prodid, prodfeatures, featureweight
         end if
         featureweight = featureweight * prodquantity
         totalfeatureweight = totalfeatureweight + featureweight
         quantity = quantity + prodquantity
         cost = cost + (prodquantity * prodprice)
      end if
   next
   TotalWeight = totalweight + Totalfeatureweight

   SetSess "Totalweight", Totalweight
end sub

' read product record to see if it has free shiping
' returns true if product does NOT have free shipping
function CheckDeliveryFree(dbc, prodid)
   ' returns true if product should be used in calculation
   dim psql, prs, rc, shippingfree
   rc = true
   ' ignore specific products from any shipping calculate if false is returned
   if GetConfig("xshippingfreeproducts")<>"Yes" then
      checkdeliveryfree = rc
      exit function
   end if

   '6.09 - always have free shipping for gift certs
   if prodid = GetConfig("xgiftproductid") then
      rc = false
      checkdeliveryfree = rc
      exit function
   end if

   psql = "select * from products where CatalogId=" & prodid
   Set prs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   '701 - 2011.03.15 - Enhancement: Speed up store performance
   prs.open psql, dbc, adOpenForwardOnly, adLockReadOnly
   if not prs.eof then
      shippingfree = prs("freeshipping")
      if not isnull(shippingfree) then
         if shippingfree<>0 then
            rc = false
         end if
      end if
   end if
   CloseRecordSet prs
   checkdeliveryfree = rc
end function

sub ShopConvertCurrencyLink (total, link)
   link = ""
   dim msg
   if GetConfig("xproductConvertCurrency")<>"Yes" then exit sub
   dim url, cprice
   cprice = ShopFormatNumber(total, GetConfig("xdecimalpoint"))
   msg = GetLang("langconvert") & " " & cprice
   url = "<a href=""#"" OnClick=""window.open('http://www.x-rates.com/cgi-bin/cgicalc.cgi?value=" & cprice & "&base=" & GetConfig("xcurrencybase") & "','','width=550,height=400,menubar=no,toolbar=no,location=no,status=no,directories=no,copyhistory=no,resizable=yes,scrollbars=yes')"">"
   url = url & msg
   url = url & "</a>"
   link = url
end sub

' creates category drop down list
sub NavigateShowContent()
   if GetConfig("xlogonrequired") = "Yes" then
      if GetSess("login") = "" then
         exit sub
      end if
   end if
   if GetConfig("init") = "" then exit sub
   dim cid, name, catSQL, i, contentlist, contentarray, contentcount
   dim strcategory, catcount, maxcontentarray, strpagename
   dim catrs, prevname, mylink
   contentcount = GetSess("contentcount")
   if contentcount = "" then contentcount = 0
   if contentcount = 0 then
      maxcontentarray = 20
      redim contentarray(maxcontentarray)
      if not dbc.state = adStateOpen then
         exit sub
      end if
      catSQL = "Select * from content where hide=0 "
      catSQL = catsql & " order by MessageType,ContentId desc"
      Set catrs = Server.CreateObject("ADODB.Recordset")
      '700 - 2010.09.26 - Enhancement: Speed up front store performance
	  '701 - 2011.03.15 - Enhancement: Speed up store performance
      catrs.open catsql, dbc, adOpenForwardOnly, adLockReadOnly
      while not catrs.eof and contentcount<maxcontentarray
         name = catrs("MessageType")
         if lcase(name)<>lcase(prevname) then
            mylink = name
            contentarray(contentcount) = name
            contentcount = contentcount + 1
            prevname = name
         end if
         catrs.MoveNext
      wend
      SetSessA "contentarray", contentarray
      SetSess "contentcount", contentcount
      '700 - 2010.05.03 - Check all databasae must close after opened.
      closerecordset catrs
   end if
   contentcount = GetSess("contentcount")
   contentarray = GetSessa("contentarray")
   if contentcount = "" then exit sub
   if contentcount = 0 then exit sub
%>
<form name='contentnavForm'>
<select name="menu" onchange = "self.location = document.contentnavForm.menu[document.contentnavForm.menu.selectedIndex].value;" class="txtfielddropdown" size="1">
<option selected><%=GetLang("langcontent")%></option>
<%
   dim url, suffix, contentlink
   strpagename = "shopcontent.asp"
   for i = 0 to contentcount -1
      contentlink = contentarray(i)
      url = "" & strPageName & "?type=" & server.urlencode(contentlink)
      url = addwebsess(url)
      response.write "<option value='" & url & "'>" & contentlink & "</option>" & vbcrlf
   next
   response.write "</select></form>"
end sub

' display all categories and their subcategories
' 5.00
' Nov 29, 2004
sub NavigateShowCategorylist
   dim sql, rs, level, rc, catdescription, spacing, categoryid
   dim highercategoryid, hassubcategory
   highercategoryid = 0
   'ShopOpenDatabaseP dbc
   navGenerateSQL sql, highercategoryid
   Set rs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   rs.open sql, dbc, adOpenStatic, adLockOptimistic
   response.write "<table width='60%'>"
   response.write "<tr>"
   response.write "<td align=left>"
   do while not rs.eof
      navGetCategoryFields rs, categoryid, hassubcategory, catdescription, rc, dbc
      if rc = 0 then
         spacing = 0
         FormatCategoryList categoryid, catdescription, spacing
         if hassubcategory<>"" then
            FormatSubCategories categoryid, spacing, dbc
         end if
      end if
      rs.movenext
   loop
   CloseRecordSet rs
   response.write "</td></tr></table>"
end sub

sub NavGetCategoryFields (rs, categoryid, hassubcategory, strcategory, rc, dbc)
   dim strcathide
   categoryid = rs("categoryid")
   strcategory = rs("catdescription")
   strcategory = TranslateLanguage(dbc, "categories", "catdescription", "categoryid", categoryid, strcategory)
   hassubcategory = rs("hassubcategory")
   if isnull(hassubcategory) then
      hassubcategory = ""
   end if
   strcathide = rs("cathide") ' hide field
   if isnull(strcathide) then
      rc = 0
   else
      rc = 4
   end if
end sub

sub navGenerateSQL (sql, highercategoryid)
   SQL = "Select * from categories "
   sql = Sql & " where highercategoryid=" & highercategoryid
   if GetConfig("xproductmatch") = "Yes" then

      '6.50 - enhanced product matching
      sql = sql & " and "
      Generateproductmatchsqlsubs sql
   end if

   '700 - Customer Groups - Matching Custormer match
   sql = sql & GenerateCustomerMatchSQL ("customermatch","excustomermatch","loggedin","and")

   if GetConfig("xselectproductsbylanguage") = "Yes" and GetSess("language")<>"" then
      '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      sql = sql & " and (catlanguage="& sqlserverprefixn &"'" & GetSess("language") & "'"
      sql = sql & " or catlanguage is null)"
   end if
   sql = sql & " order by " & GetConfig("xsortcategories")
end sub

sub FormatCategoryList (id, name, spacing)
   dim i
   if spacing>0 then
      for i = 0 to spacing
         response.write "&nbsp;&nbsp;"
      next
   end if
   '700 - SEO
   dim mylink
   if getconfig("xSEODynamicEnable") = "Yes" and getconfig("xSEODynamicProductsEnable") = "Yes" then
      genseocategoryproductlink mylink,id,name,name,"","Yes"
	  htmlwrite mylink
   else
      htmlwrite "<a href=""shopdisplayproducts.asp?id=" & id & "&amp;cat=" & Server.URLEncode(replace(name,"&amp;","&")) & """>" & name & "</a>" & "<br />" & vbcrlf
   end if
end sub

sub FormatSubCategories (categoryid, spacing, dbc)
   dim sql, rs, rc, catdescription, hassubcategory
   navGenerateSQL sql, categoryid
   Set rs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   rs.open sql, dbc, adOpenStatic, adLockOptimistic
   spacing = spacing + 1
   do while not rs.eof
      navGetCategoryFields rs, categoryid, hassubcategory, catdescription, rc, dbc
      if rc = 0 then
         FormatCategoryList categoryid, catdescription, spacing
         if hassubcategory<>"" then
            FormatSubCategories categoryid, spacing, dbc
         end if
      end if
      rs.movenext
   loop
   spacing = spacing -1
   CloseRecordSet rs
end sub

' 7.001 Move All Layout Elements To Template Files
'***************************************************************************
sub FormatassociatedProducts (dbc, sql, headercaption, displaylimit)
   dim rs, strxProCatDisplaytemplateinvent, strxProCatDisplaytemplate, limit, dcount

   strxProCatDisplaytemplateinvent = getconfig("xProExdDisplaytemplateinvent")
   strxProCatDisplaytemplate = getconfig("xProExdDisplaytemplate")
   if strxProCatDisplaytemplateinvent = "" or strxProCatDisplaytemplate = "" then
      shoperror "xProExdCrossSellingTemplate and xProExdCrossSellingTemplateInvent"& GetLang("langerrmusthavevalue") &""
      exit sub
   end if

   if displaylimit = "" then
      limit = 99999
   else
      limit = clng(displaylimit)
   end if
   dcount = 0
   Set rs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   rs.open sql, dbc, adOpenStatic, adLockOptimistic
   if not rs.eof then
      HtmlWrite "<span class='fontbold'>"& headercaption &"</span><br />"
      do while not rs.eof and dcount<limit
         if rs("hassubproduct") = "Yes" then
            ShopTemplateWrite strxProCatDisplaytemplateinvent, rs, rc
         elseif rs("features")<>"" and isnull(rs("features")) = false then
            ShopTemplateWrite strxProCatDisplaytemplateinvent, rs, rc
         else
            ShopTemplateWrite strxProCatDisplaytemplate, rs, rc
         end if
         rs.movenext
         dcount = dcount + 1
      loop
   end if
   closerecordset rs
end sub

' format one row of crossselling.
' all products must have an image
sub FormatAssociatedrow (rs)
   dim hideprice
   hideprice = false
   if GetConfig("xdisplayprices") <> "Yes" then
      hideprice = true
   end if
   if GetConfig("xpriceloggedinonly") = "Yes" then
      if GetSess ("login") = "" then
         hideprice = true
      end if
   end if
   dim CatalogId, imagefile, cname, cprice, url, cdescription
   dim buttonimage, buttontext, buttonname
   buttonimage = GetConfig("xbuttonmoreinfo")
   buttontext = GetLang("langProductExtendeddescription")
   buttonname = "View"
   if isnull(buttonimage) or buttonimage = "" then
      buttonimage = ""
   end if
   CatalogId = rs("CatalogId")
   imagefile = rs("cimageurl")
   URL = rs("cdescurl")
   if isnull(url) then
      URL = GetConfig("xCrossLinkURL")
   end if
   if ucase(URL) = "SHOPEXD.ASP" then
      url = "shopexd.asp?id=" & rs("CatalogId") & "&bc=no"
      '700 - SEO
      genseoproductlink url,rs("CatalogId"),"","No"
      if getconfig("xSEODynamicEnable") = "Yes" and getconfig("xSEODynamicProductsEnable") = "Yes" then
	     url = url & "?bc=no"
	  end if
   else
      url = "shopquery.asp?CatalogId=" & rs("CatalogId") & "&bc=no"
   end if

   '6.50 - advanced session handling
   url = addwebsess(url)

   'add translate
   cname = rs("cname")
   cdescription = rs("cdescription")
   cname = TranslateLanguage(dbc, "products", "cname", "CatalogId", CatalogId, cname)
   cdescription = TranslateLanguage(dbc, "products", "cdescription", "CatalogId", CatalogId, cdescription)
%>
<table width="100%" border="0" cellspacing="2" cellpadding="2">
<tr>
<td width="20%" valign="top">
<a href="<%=url%>"><img src="<%=imagefile%>" width='60' height='60' border='0'></a>
</td>
<td width="50%" valign="top" align="left">
<span class=hdrproduct><a href="<%=url%>"><%=cname%></a></span> <br />
<%=cdescription%>
</td>
<td width="30%" align="right" valign="top">
<%
   if hideprice <> true then %>
<%=GetLang("langourprice")%>: <span class='price'><%=ShopFormatCurrency(rs("cprice"), GetConfig("xdecimalpoint"))%></span><br />
<%
   end if%>
<p>
<span class='fontbold'><a href="<%=url%>"><%=GetLang("langproductclick")%></a></span>
</p>
</td>
</tr>
</table>
<%
end sub

sub loginlogouttoggle
   '6.08 - restore cookie if enabled so this displays correctly
   if GetConfig("xcookielogin") = "Yes" then
      RestoreCustomerDetailsCookie
   end if

   if GetSess ("lastname") > "" then
      '6.50 - advanced session handling
%>
<a href="shopcustadminlogin.asp?new=yes<%=addwebsesslink%>"><%=GetLang("langcommonlogout")%></a>
<%
   else
      '6.50 - advanced session handling
%>
<a href="shopcustadminlogin.asp<%=addwebsesslinkfirst%>"><%=GetLang("langcommonlogin")%></a>
<%
   end if
end sub

sub welcomenote
   '6.08 - restore cookie if enabled so this displays correctly
   if GetConfig("xcookielogin") = "Yes" then
      RestoreCustomerDetailsCookie
   end if

   if GetSess ("lastname") > "" then
      'response.write GetLang("langloggedinas") & " " & GetSess("Firstname") & " " & GetSess("lastname")
	  response.write GetLang("langcommonwelcome") & ", " & GetSess("Firstname")
   else
      response.write GetLang("langcommonwelcome") & ", " & GetLang("langcommonguest")
   end if
end sub

sub DisplayIPAddress
   dim ipaddress
   ipaddress = request.servervariables("REMOTE_ADDR")

   if GetConfig("xdisplayIPAddress") = "Yes" then
%>
<br /><br />
<table class="ipwarningtable" width="99%" border="0" cellspacing="4" cellpadding="4" align="center">
  <tr>
    <td width="14%" class="small al">
      <img src="images/misc/warn.gif" alt=" " />
    </td>
    <td width="86%" class="small al">
      <%=GetLang("langipwarn01")%>
    </td>
  </tr>
  <tr>
    <td width="14%" class="small al">
      &nbsp;
    </td>
    <td>
      <span class='fontbold'><%=request.ServerVariables("REMOTE_ADDR") & "<br />"%></span>
    </td>
  </tr>
  <tr>
    <td width="14%" class="small al">
      &nbsp;
    </td>
    <td width="86%" class="small al">
      <%=GetLang("langipwarn02")%>
    </td>
  </tr>
</table>
<%
   end if
end sub

sub inserturchinstats
end sub

sub NavigateFeaturedProducts
   if GetConfig("xlogonrequired") = "Yes" then
      if GetSess("Login") = "" then
         exit sub
      end if
   end if
   if GetConfig("xshopclosed") = "Yes" then
      if GetSess("Login") = "Force" then
         exit sub
      end if
      if GetSess("shopadmin") = "" then
         ShopError GetLang("Langshopclosed")
      end if
   end if

   dim strsql, useorderdb
   dim rs

   strsql = "select distinct p.catalogid,p.featuredflagorder, p.cstock AS sumofnumitems from products p, prodcategories cc, categories c where "
   strsql = strsql & " cc.intCatalogId=p.CatalogId and cc.intcategoryid=c.categoryid and "
   if instr(ucase(xdatabasetype), "MYSQL") > 0 or instr(ucase(xdatabasetype), "SQLSERVER") > 0 then
      strsql = strsql & " p.featuredflag = 1"
   else
      strsql = strsql & " p.featuredflag = TRUE"
   end if

   '700 - generate sql by product criteria - 2010.04.03
   generateproductstdcriteriasql strsql, "p.", "c.", "generateproductmatchsqlsubs"
   
   strsql = strsql & " order by p.featuredflagorder asc "
   
   Set rs = Server.CreateObject("ADODB.Recordset")

   '700 - 2010.08.13 - Bug Fix: To cover the distinct with ntext type issue
   ShopOpenRecordSet strsql, rs, 999, 1

   '7.001 Move All Layout Elements To Template Files
   '700 - 2010.08.13 - Bug Fix: To cover the distinct with ntext type issue
   dim ptemplate
   ptemplate = getconfig("productfeaturestemplate")
   if trim(ptemplate) = "" then
      ptemplate = "tmp_featuredproducts.htm"
   end if
   '700 - 2010.08.13 - Bug Fix: To cover the distinct with ntext type issue
   ProduceFeatureProDetail rs,ptemplate

   CloseRecordSet rs
end sub

'700 - layout manager enhancement - 2010.03.30 - cutom featuredflag and featuredflagorder
sub NavigateFeaturedProductsNew (featuredflag,featuredflagorder)
   if trim(featuredflag) = "" or isnull(featuredflag) then featuredflag = "featuredflag"
   if trim(featuredflagorder) = "" or isnull(featuredflagorder) then featuredflagorder = "featuredflagorder"

   if GetConfig("xlogonrequired") = "Yes" then
      if GetSess("Login") = "" then
         exit sub
      end if
   end if
   if GetConfig("xshopclosed") = "Yes" then
      if GetSess("Login") = "Force" then
         exit sub
      end if
      if GetSess("shopadmin") = "" then
         ShopError GetLang("Langshopclosed")
      end if
   end if

   dim strsql, useorderdb
   dim rs

   strsql = "select distinct p.catalogid,p."& featuredflagorder &", p.cstock AS sumofnumitems from products p, prodcategories cc, categories c where "
   strsql = strsql & " cc.intCatalogId=p.CatalogId and cc.intcategoryid=c.categoryid and "
   if instr(ucase(xdatabasetype), "MYSQL") > 0 or instr(ucase(xdatabasetype), "SQLSERVER") > 0 then
      strsql = strsql & " p."& featuredflag &" = 1"
   else
      strsql = strsql & " p."& featuredflag &" = TRUE"
   end if

   '700 - generate sql by product criteria - 2010.04.03
   generateproductstdcriteriasql strsql, "p.", "c.", "generateproductmatchsqlsubs"
   
   strsql = strsql & " order by p."& featuredflagorder &" asc "
   
   Set rs = Server.CreateObject("ADODB.Recordset")

   '700 - 2010.08.13 - Bug Fix: To cover the distinct with ntext type issue
   ShopOpenRecordSet strsql, rs, 999, 1

   '7.001 Move All Layout Elements To Template Files
   '700 - 2010.08.13 - Bug Fix: To cover the distinct with ntext type issue
   dim ptemplate
   ptemplate = getconfig("productfeaturestemplate")
   if trim(ptemplate) = "" then
      ptemplate = "tmp_featuredproducts.htm"
   end if
   '700 - 2010.08.13 - Bug Fix: To cover the distinct with ntext type issue
   ProduceFeatureProDetail rs,ptemplate
   
   CloseRecordSet rs
end sub

' xproductmatch can be a list of shopids
' a,b,ddd,ee
' add them all to the sql
sub GenerateProductmatchsqlsubs (sql)
   dim shops(50), shopcount, i
   dim addpprefixstr
   if instr(sql,"products p") > 0 then
      addpprefixstr = "p.productmatch"
   else
      addpprefixstr = "productmatch"
   end if
   ParseRecord xproductmatch, shops, shopcount, "," ' get all shops allowed
   sql = sql & " ("
   for i = 0 to shopcount -1
      if i>0 then
         sql = sql & " or "
      end if
	  '7.00 - product matching enhancement
	  if instr(lcase(xdatabasetype),"mysql") > 0 then
	     sql = sql & " concat(',',"& addpprefixstr &",',') like '%," & shops(i) & ",%'"
	  else
	     '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
	     sql = sql & " ',' + "& addpprefixstr &" + ',' like "& sqlserverprefixn &"'%," & shops(i) & ",%'"
	  end if
   next
   sql = sql & " or "& addpprefixstr &" is null or "& addpprefixstr &" = '')"
end sub

' 6.50
' xproductmatch can be a list of shopids
' a,b,ddd,ee
' add them all to the sql
sub GenerateProductmatchsqlsubscat (sql)
   dim shops(50), shopcount, i
   ParseRecord xproductmatch, shops, shopcount, "," ' get all shops allowed
   sql = sql & " ("
   for i = 0 to shopcount -1
      if i>0 then
         sql = sql & " or "
      end if
	  '7.00 - product matching enhancement
	  if instr(lcase(xdatabasetype),"mysql") > 0 then
	     sql = sql & " concat(',',productmatch,',') like '%," & shops(i) & ",%'"
	  else
	     '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
	     sql = sql & " ',' + productmatch + ',' like "& sqlserverprefixn &"'%," & shops(i) & ",%'"
	  end if
   next
   '6.5 - removed " and highercategoryid = 0" from line below
   sql = sql & " or (productmatch is null or productmatch = ''))"
end sub

'700 - generate sql by product criteria - 2010.04.03
sub generateproductstdcriteriasql(sql, withp, withc, productmatchroutinename)
   dim lngcstock

   if lcase(right(trim(sql),3)) = "and" or lcase(right(trim(sql),2)) = "or" then
      sql = sql & " "& withp &"hide = 0"
   else
      sql = sql & " and "& withp &"hide = 0"
   end if
   
   '701 - 2011.02.16 - Enhancement: Speed enhancement
   dim xstocklow
   xstocklow = GetConfig("xstocklow")
   if xstocklow<>"" then
      '701 - 2011.01.06 - Bug Fix: Out of stock message is displaying wrongly at shopexd.asp
      if session("fromshopexd") <> "Yes" then
         lngcstock = clng(xstocklow)
         sql = sql & " and "& withp &"cstock > " & lngcstock
      else
	     '701 - 2011.05.16 - Enhancement: Better handling on xoutofstocklimit at shopexd.asp
	     if getconfig("xoutofstocklimit") = "" then
            lngcstock = clng(xstocklow)
            sql = sql & " and "& withp &"cstock > " & lngcstock
		 end if
	  end if
	  session("fromshopexd") = ""
   end if

   if GetConfig("xproductmatch") = "Yes" then
      '6.50 - enhanced product matching
      sql = sql & " and "
	  select case lcase(productmatchroutinename)
	     case "generateproductmatchsql"
		    generateproductmatchsql sql
		 case "generateproductmatchsqlsubs"
		    generateproductmatchsqlsubs sql
	  end select
   end if

   '700 - Customer Groups - Matching Custormer match
   sql = sql & GenerateCustomerMatchSQL (""& withp &"customermatch",""& withp &"excustomermatch",""& withp &"loggedin","and")
   if trim(withc) <> "" then sql = sql & GenerateCustomerMatchSQL (""& withc &"customermatch",""& withc &"excustomermatch",""& withc &"loggedin","and")
   
   if GetConfig("xselectproductsbylanguage") = "Yes" and GetSess("language")<>"" then
      '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      sql = sql & " and ("& withp &"clanguage="& sqlserverprefixn &"'" & GetSess("language") & "'"
      sql = sql & " or "& withp &"clanguage is null)"
   end if
end sub

'700 - 2010.08.13 - Bug Fix: To cover the distinct with ntext type issue
sub ProduceFeatureProDetail (rs,ptemplate)
   dim lngCatalogId, psql, prs
   
   setsess "homepagefprecord",""
   do while not rs.eof
      lngCatalogId = rs("CatalogId")
      psql = "select * from products where CatalogId = " & lngCatalogId

      Set prs = Server.CreateObject("ADODB.Recordset")
	  ShopOpenRecordSet psql, prs, 999, 1
      if not prs.eof then
         dim rc
		 prs.movefirst
		 setsess "homepagefprecord","yes"
		 ShopTemplateWrite ptemplate, prs, rc
      end if
      CloseRecordSet prs
      rs.movenext
   loop
end sub
%>